#include "ags_line.h"

#include "../audio/ags_channel.h"

GType ags_line_get_type(void);
void ags_line_class_init(AgsLineClass *line);
void ags_line_init(AgsLine *line);
void ags_line_destroy(GtkObject *object);
void ags_line_show(GtkWidget *widget);
void ags_line_connect(AgsLine *line);

extern void (*gtk_container_destroy)(GtkObject *object);
extern void (*gtk_widget_real_show)(GtkWidget *widget);

GType
ags_line_get_type(void)
{
  static GType line_type = 0;

  if (!line_type){
    static const GtkTypeInfo line_info = {
      "AgsLine\0",
      sizeof(AgsLine), /* base_init */
      sizeof(AgsLineClass), /* base_finalize */
      (GtkClassInitFunc) ags_line_class_init,
      (GtkObjectInitFunc) ags_line_init,
      NULL, /* class_finalize */
      NULL, /* class_data */
      (GtkClassInitFunc) NULL,
    };
    line_type = gtk_type_unique (GTK_TYPE_MENU_ITEM, &line_info);
  }

  return (line_type);
}

void
ags_line_class_init(AgsLineClass *line)
{
  GtkObjectClass *object = (GtkObjectClass *) line;
  GtkWidgetClass *widget = (GtkWidgetClass *) line;

  object->destroy = ags_line_destroy;

  widget->show = ags_line_show;
}

void
ags_line_init(AgsLine *line)
{
  line->channel = NULL;

  line->table = (GtkTable *) gtk_table_new(2, 2, FALSE);
  gtk_container_add((GtkContainer *) line, (GtkWidget *) line->table);
}

void
ags_line_destroy(GtkObject *object)
{
  AgsLine *line = (AgsLine *) object;
  GList *list0, *list1;

  list0 = gtk_container_get_children((GtkContainer *) line->table);

  while(list0 != NULL){
    list1 = list0->next;

    gtk_widget_destroy((GtkWidget *) list0->data);

    list0 = list1;
  }

  gtk_widget_destroy((GtkWidget *) line->table);

  if(gtk_container_destroy)
    gtk_container_destroy(object);
}

void
ags_line_show(GtkWidget *widget)
{
  AgsLine *line = (AgsLine *) widget;

  if(gtk_widget_real_show)
    gtk_widget_real_show(widget);

  gtk_widget_show_all((GtkWidget *) line->table);
}

void
ags_line_connect(AgsLine *line)
{
}

AgsLine*
ags_line_new()
{
  AgsLine *line;

  line = (AgsLine *) g_object_new(AGS_TYPE_LINE, NULL);
  
  return(line);
}
