#include "ags_line_editor.h"

GType ags_line_editor_get_type(void);
void ags_line_editor_class_init(AgsLineEditorClass *line_editor);
void ags_line_editor_init(AgsLineEditor *line_editor);
void ags_line_editor_destroy(GtkObject *object);
void ags_line_editor_show(GtkWidget *widget);
void ags_line_editor_connect(AgsLineEditor *line_editor);

extern void (*gtk_container_destroy)(GtkObject *object);
extern void (*gtk_widget_real_show)(GtkWidget *widget);

GType
ags_line_editor_get_type(void)
{
  static GType line_editor_type = 0;

  if (!line_editor_type){
    static const GtkTypeInfo line_editor_info = {
      "AgsLineEditor\0",
      sizeof(AgsLineEditor), /* base_init */
      sizeof(AgsLineEditorClass), /* base_finalize */
      (GtkClassInitFunc) ags_line_editor_class_init,
      (GtkObjectInitFunc) ags_line_editor_init,
      NULL, /* class_finalize */
      NULL, /* class_data */
      (GtkClassInitFunc) NULL,
    };

    line_editor_type = gtk_type_unique (GTK_TYPE_VBOX, &line_editor_info);
  }

  return (line_editor_type);
}

void
ags_line_editor_class_init(AgsLineEditorClass *line_editor)
{
  GtkObjectClass *object = (GtkObjectClass *) line_editor;
  GtkWidgetClass *widget = (GtkWidgetClass *) line_editor;

  object->destroy = ags_line_editor_destroy;
  widget->show = ags_line_editor_show;
}

void
ags_line_editor_init(AgsLineEditor *line_editor)
{
  line_editor->link_editor = ags_link_editor_new();
  gtk_box_pack_start((GtkBox*) line_editor,
		     (GtkWidget *) line_editor->link_editor,
		     FALSE, FALSE, 0);
}

void
ags_line_editor_destroy(GtkObject *object)
{
  if(gtk_container_destroy)
    gtk_container_destroy(object);
}

void
ags_line_editor_show(GtkWidget *widget)
{
  AgsLineEditor *line_editor = (AgsLineEditor *) widget;

  gtk_widget_show((GtkWidget *) line_editor->link_editor);

  if(gtk_widget_real_show)
    gtk_widget_real_show(widget);
}

void
ags_line_editor_connect(AgsLineEditor *line_editor)
{
  ags_link_editor_connect(line_editor->link_editor);
}

AgsLineEditor*
ags_line_editor_new()
{
  AgsLineEditor *line_editor;

  line_editor = (AgsLineEditor *) g_object_new(AGS_TYPE_LINE_EDITOR, NULL);

  return(line_editor);
}
