#ifndef __AGS_MACHINE_H__
#define __AGS_MACHINE_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gtk/gtkhandlebox.h>
#include <gtk/gtkdialog.h>

#include "../audio/ags_audio.h"
#include "../file/ags_file.h"

#define AGS_TYPE_MACHINE                (ags_machine_get_type())
#define AGS_MACHINE(obj)                ((AgsMachine*) G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_MACHINE, AgsMachine))
#define AGS_MACHINE_CLASS(class)        ((AgsMachineClass*) G_TYPE_CHECK_CLASS_CAST(class, AGS_TYPE_MACHINE, AgsMachineClass))
#define AGS_MACHINE_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS((obj), AGS_TYPE_MACHINE, AgsMachineClass))

#define AGS_TYPE_MACHINE_POPUP          (ags_machine_popup_get_type ())
#define AGS_MACHINE_POPUP(obj)          (G_TYPE_CHECK_INSTANCE_CAST ((obj), AGS_TYPE_MACHINE_POPUP, AgsMachinePopup))
#define AGS_MACHINE_POPUP_CLASS(class)  (G_TYPE_CHECK_CLASS_CAST ((class), AGS_TYPE_MACHINE_POPUP, AgsMachinePopupClass))

typedef struct _AgsMachine AgsMachine;
typedef struct _AgsMachineClass AgsMachineClass;
typedef struct _AgsMachinePopup AgsMachinePopup;
typedef struct _AgsMachinePopupClass AgsMachinePopupClass;

struct _AgsMachine
{
  GtkHandleBox handle_box;

  char *name;

  AgsAudio *audio;

  GtkDialog *properties;
  GtkDialog *rename;
};

struct _AgsMachineClass
{
  GtkHandleBoxClass handle_box;

  void (*read_file)(AgsFile *file, AgsMachine *machine);
  void (*write_file)(AgsFile *file, AgsMachine *machine);
};

struct _AgsMachinePopup
{
  GtkMenu menu;

  AgsMachine *machine;
};

struct _AgsMachinePopupClass
{
  GtkMenuClass menu_class;
};

AgsMachine* ags_machine_new();

AgsMachinePopup* ags_machine_popup_new(AgsMachine *machine);

#endif /*__AGS_MACHINE_H__*/
