#include "ags_machine_callbacks.h"

#include "ags_window.h"
#include "ags_machine_editor.h"

int
ags_machine_button_press_callback(GtkWidget *handle_box, GdkEventButton *event, AgsMachine *machine)
{
  AgsWindow *window = AGS_WINDOW (gtk_widget_get_toplevel (GTK_WIDGET(handle_box)));

  if(event->button == 3)
    gtk_menu_popup (GTK_MENU (ags_machine_popup_new (machine)),
                    NULL, NULL, NULL, NULL,
                    event->button, event->time);
  else if(event->button == 1)
    window->selected = machine;

  return(0);
}

int
ags_machine_popup_move_up_activate_callback(GtkWidget *widget, AgsMachinePopup *popup)
{
  return(0);
}

int
ags_machine_popup_move_down_activate_callback(GtkWidget *widget, AgsMachinePopup *popup)
{
  return(0);
}

int
ags_machine_popup_hide_activate_callback(GtkWidget *widget, AgsMachinePopup *popup)
{
  return(0);
}

int
ags_machine_popup_destroy_activate_callback(GtkWidget *widget, AgsMachinePopup *popup)
{
  return(0);
}

int
ags_machine_popup_rename_activate_callback(GtkWidget *widget, AgsMachinePopup *popup)
{
  GtkDialog *dialog;
  GtkEntry *entry;

  dialog = (GtkDialog *) gtk_dialog_new_with_buttons("rename\0",
						     (GtkWindow *) gtk_widget_get_toplevel(GTK_WIDGET(popup->machine)),
						     GTK_DIALOG_DESTROY_WITH_PARENT,
						     GTK_STOCK_OK,
						     GTK_RESPONSE_ACCEPT,
						     GTK_STOCK_CANCEL,
						     GTK_RESPONSE_REJECT,
						     NULL);

  entry = (GtkEntry *) gtk_entry_new();
  gtk_entry_set_text(entry, popup->machine->name);
  gtk_box_pack_start((GtkBox *) dialog->vbox, (GtkWidget *) entry, FALSE, FALSE, 0);

  gtk_widget_show_all((GtkWidget *) dialog);

  return(0);
}

int
ags_machine_popup_properties_activate_callback(GtkWidget *widget, AgsMachinePopup *popup)
{
  popup->machine->properties = (GtkDialog*) ags_machine_editor_new();
  AGS_MACHINE_EDITOR(popup->machine->properties)->machine = popup->machine;
  gtk_widget_show((GtkWidget *) popup->machine->properties);
  ags_machine_editor_connect((AgsMachineEditor*) popup->machine->properties);

  return(0);
}

