#ifndef __AGS_MACHINE_EDITOR_H__
#define __AGS_MACHINE_EDITOR_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>

#include "ags_machine.h"

#define AGS_TYPE_MACHINE_EDITOR                (ags_machine_editor_get_type())
#define AGS_MACHINE_EDITOR(obj)                ((AgsMachineEditor*) G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_MACHINE_EDITOR, AgsMachineEditor))
#define AGS_MACHINE_EDITOR_CLASS(class)        ((AgsMachineEditorClass*) G_TYPE_CHECK_CLASS_CAST(class, AGS_TYPE_MACHINE_EDITOR, AgsMachineEditorClass))

typedef struct _AgsMachineEditor AgsMachineEditor;
typedef struct _AgsMachineEditorClass AgsMachineEditorClass;

struct _AgsMachineEditor
{
  GtkDialog dialog;

  AgsMachine *machine;

  GtkNotebook *notebook;

  GtkScrolledWindow *output_scrolled_window;
  GtkVBox *output;

  GtkScrolledWindow *input_scrolled_window;
  GtkVBox *input;

  GtkDialog *add;
  GtkDialog *remove;
};

struct _AgsMachineEditorClass
{
  GtkDialogClass dialog;
};

AgsMachineEditor* ags_machine_editor_new();

#endif /*__AGS_MACHINE_EDITOR_H__*/
