#include "ags_menu_bar_callbacks.h"
#include "machine/ags_panel.h"
#include "machine/ags_mixer.h"
#include "machine/ags_drum.h"
#include "machine/ags_matrix.h"
#include "machine/ags_synth.h"
#include "machine/ags_ffplayer.h"
#include "ags_window.h"

int
ags_menu_bar_open_callback(GtkWidget *menu_item, AgsMenuBar *menu_bar)
{
  return(0);
}

int
ags_menu_bar_save_callback(GtkWidget *menu_item, AgsMenuBar *menu_bar)
{
  return(0);
}

int
ags_menu_bar_save_as_callback(GtkWidget *menu_item, AgsMenuBar *menu_bar)
{
  return(0);
}

int
ags_menu_bar_quit_callback(GtkWidget *menu_item, AgsMenuBar *menu_bar)
{
  gtk_main_quit();

  return(0);
}


int
ags_menu_bar_add_callback(GtkWidget *menu_item, AgsMenuBar *menu_bar)
{
  return(0);
}


int
ags_menu_bar_add_panel_callback(GtkWidget *menu_item, AgsMenuBar *menu_bar)
{
  GtkWidget *widget;
  AgsWindow *window;

  window = (AgsWindow *) gtk_widget_get_ancestor((GtkWidget *) menu_bar, AGS_TYPE_WINDOW);

  gtk_box_pack_start((GtkBox *) window->machines,
		     (widget = (GtkWidget*) ags_panel_new()),
		     FALSE, FALSE, 0);

  ags_machine_connect((AgsMachine *) widget);
  gtk_widget_show_all(widget);

  return(0);
}

int
ags_menu_bar_add_mixer_callback(GtkWidget *menu_item, AgsMenuBar *menu_bar)
{
  GtkWidget *widget;
  AgsWindow *window;

  window = (AgsWindow *) gtk_widget_get_ancestor((GtkWidget *) menu_bar, AGS_TYPE_WINDOW);

  gtk_box_pack_start((GtkBox *) window->machines,
		     (widget = (GtkWidget*) ags_mixer_new()),
		     FALSE, FALSE, 0);

  ags_machine_connect((AgsMachine *) widget);
  gtk_widget_show_all(widget);

  return(0);
}

int
ags_menu_bar_add_drum_callback(GtkWidget *menu_item, AgsMenuBar *menu_bar)
{
  GtkWidget *widget;
  AgsWindow *window;

  window = (AgsWindow *) gtk_widget_get_ancestor((GtkWidget *) menu_bar, AGS_TYPE_WINDOW);

  gtk_box_pack_start((GtkBox *) window->machines,
		     (widget = (GtkWidget*) ags_drum_new()),
		     FALSE, FALSE, 0);

  ags_drum_connect((AgsMatrix *) widget);
  ags_machine_connect((AgsMachine *) widget);
  gtk_widget_show_all(widget);

  return(0);
}

int
ags_menu_bar_add_matrix_callback(GtkWidget *menu_item, AgsMenuBar *menu_bar)
{
  GtkWidget *widget;
  AgsWindow *window;

  window = (AgsWindow *) gtk_widget_get_ancestor((GtkWidget *) menu_bar, AGS_TYPE_WINDOW);

  gtk_box_pack_start((GtkBox *) window->machines,
		     (widget = (GtkWidget*) ags_matrix_new()),
		     FALSE, FALSE, 0);

  ags_matrix_connect((AgsMatrix *) widget);
  ags_machine_connect((AgsMachine *) widget);
  gtk_widget_show_all(widget);

  return(0);
}

int
ags_menu_bar_add_synth_callback(GtkWidget *menu_item, AgsMenuBar *menu_bar)
{
  GtkWidget *widget;
  AgsWindow *window;

  window = (AgsWindow *) gtk_widget_get_ancestor((GtkWidget *) menu_bar, AGS_TYPE_WINDOW);

  gtk_box_pack_start((GtkBox *) window->machines,
		     (widget = (GtkWidget*) ags_synth_new()),
		     FALSE, FALSE, 0);

  ags_machine_connect((AgsMachine *) widget);
  gtk_widget_show_all(widget);

  return(0);
}

int
ags_menu_bar_add_ffplayer_callback(GtkWidget *menu_item, AgsMenuBar *menu_bar)
{
  GtkWidget *widget;
  AgsWindow *window;

  window = (AgsWindow *) gtk_widget_get_ancestor((GtkWidget *) menu_bar, AGS_TYPE_WINDOW);

  gtk_box_pack_start((GtkBox *) window->machines,
		     (widget = (GtkWidget*) ags_ffplayer_new()),
		     FALSE, FALSE, 0);

  ags_machine_connect((AgsMachine *) widget);
  gtk_widget_show_all(widget);

  return(0);
}


int
ags_menu_bar_remove_callback(GtkWidget *menu_item, AgsMenuBar *menu_bar)
{
  return(0);
}
