#ifndef __AGS_WINDOW_H__
#define __AGS_WINDOW_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gtk/gtkwindow.h>
#include <gtk/gtkvbox.h>

#include "ags_machine.h"

#define AGS_TYPE_WINDOW                (ags_window_get_type())
#define AGS_WINDOW(obj)                ((AgsWindow*) G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_WINDOW, AgsWindow))
#define AGS_WINDOW_CLASS(class)        ((AgsWindowClass*) G_TYPE_CHECK_CLASS_CAST(class, AGS_TYPE_WINDOW, AgsWindowClass))

typedef struct _AgsWindow AgsWindow;
typedef struct _AgsWindowClass AgsWindowClass;
typedef struct _AgsMachineCounter AgsMachineCounter;

struct _AgsWindow
{
  GtkWindow window;

  GtkVBox *machines;
  AgsMachineCounter *counter;
  AgsMachine *selected;
};

struct _AgsWindowClass
{
  GtkWindowClass window;
};

struct _AgsMachineCounter
{
  guint everything;

  guint panel;
  guint mixer;
  guint drum;
  guint matrix;
  guint synth;
  guint ffplayer;
};

AgsWindow* ags_window_new();

#endif /*__AGS_WINDOW_H__*/
