#ifndef __AGS_DRUM_H__
#define __AGS_DRUM_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>

#include "../ags_machine.h"
#include "../ags_pad.h"

#include <gtk/gtktogglebutton.h>

#define AGS_TYPE_DRUM                (ags_drum_get_type())
#define AGS_DRUM(obj)                ((AgsDrum*) G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_DRUM, AgsDrum))
#define AGS_DRUM_CLASS(class)        ((AgsDrumClass*) G_TYPE_CHECK_CLASS_CAST(class, AGS_TYPE_DRUM, AgsDrumClass))

typedef struct _AgsDrum AgsDrum;
typedef struct _AgsDrumClass AgsDrumClass;

typedef enum{
  AGS_DRUM_BLOCK_PATTERN,
}AgsDrumFlags;

struct _AgsDrum
{
  AgsMachine machine;

  guint flags;

  GtkVBox *vbox;

  GtkHBox *pad;

  GList *edit_button;
  GtkToggleButton *selected_edit_button;

  AgsPad *selected_pad;
  AgsLine *selected_line;

  GtkToggleButton *index0[4];
  GtkToggleButton *selected0;

  GtkToggleButton *index1[12];
  GtkToggleButton *selected1;

  GtkHBox *pattern;
  gboolean block_pattern;

  GtkVBox *offset;
};

struct _AgsDrumClass
{
  AgsMachineClass machine;
};

AgsDrum* ags_drum_new();

#endif /*__AGS_DRUM_H__*/
