#include "ags_drum_callbacks.h"

#include "../ags_pad.h"

#include "../../audio/ags_pattern.h"

void ags_drum_set_pattern(AgsDrum *drum);

int
ags_drum_edit_callback(GtkWidget *toggle_button, AgsDrum *drum)
{
  GtkToggleButton *toggle;

  if(drum->selected_edit_button != NULL){
    if(GTK_TOGGLE_BUTTON(toggle_button) != drum->selected_edit_button){
      toggle = drum->selected_edit_button;
      drum->selected_edit_button = NULL;
      gtk_toggle_button_set_active((GtkToggleButton *) toggle, FALSE);
      drum->selected_edit_button = (GtkToggleButton *) toggle_button;
      drum->selected_pad = (AgsPad *) gtk_widget_get_ancestor((GtkWidget *) toggle_button, AGS_TYPE_PAD);
      ags_drum_set_pattern(drum);
    }else{
      toggle = drum->selected_edit_button;
      drum->selected_edit_button = NULL;
      gtk_toggle_button_set_active((GtkToggleButton *) toggle, TRUE);
      drum->selected_edit_button = toggle;
    }
  }
}

int
ags_drum_index0_callback(GtkWidget *widget, AgsDrum *drum)
{
  if(drum->selected0 != NULL){
    GtkToggleButton *toggle_button;

    if(GTK_TOGGLE_BUTTON(widget) != drum->selected0){
      toggle_button = drum->selected0;
      drum->selected0 = NULL;
      gtk_toggle_button_set_active(toggle_button, FALSE);
      drum->selected0 = (GtkToggleButton*) widget;
    }else if(! gtk_toggle_button_get_active(drum->selected0)){
      toggle_button = drum->selected0;
      drum->selected0 = NULL;
      gtk_toggle_button_set_active((GtkToggleButton *) widget, TRUE);
      drum->selected0 = (GtkToggleButton*) widget;
    }

    ags_drum_set_pattern(drum);
  }

  return(0);
}

int
ags_drum_index1_callback(GtkWidget *widget, AgsDrum *drum)
{
  if(drum->selected1 != NULL){
    GtkToggleButton *toggle_button;

    if(GTK_TOGGLE_BUTTON(widget) != drum->selected1){
      toggle_button = drum->selected1;
      drum->selected1 = NULL;
      gtk_toggle_button_set_active(toggle_button, FALSE);
      drum->selected1 = (GtkToggleButton*) widget;
    }else if(! gtk_toggle_button_get_active(drum->selected1)){
      toggle_button = drum->selected1;
      drum->selected1 = NULL;
      gtk_toggle_button_set_active((GtkToggleButton *) widget, TRUE);
      drum->selected1 = (GtkToggleButton*) widget;
    }

    ags_drum_set_pattern(drum);
  }

  return(0);
}

int
ags_drum_pad_callback(GtkWidget *toggle_button, AgsDrum *drum)
{
  AgsPattern *pattern;
  GList *list;
  guint i, index0, index1, offset;

  if(drum->block_pattern){ /* AGS_DRUM_BLOCK_PATTERN & drum->flags */
    printf("AgsDrum pattern is blocked\n\0");
    return;
  }

  list = gtk_container_get_children((GtkContainer *) drum->pattern);

  for(i = 0; i < 16 && toggle_button != list->data; i++)
    list = list->next;

  offset = i;

  for(i = 0; i < 4 && drum->selected0 != drum->index0[i]; i++);

  index0 = i;

  for(i = 0; i < 12 && drum->selected1 != drum->index1[i]; i++);
  
  index1 = i;

  list = gtk_container_get_children((GtkContainer *) drum->offset);

  for(i = 0; i < 4 && ! GTK_TOGGLE_BUTTON(list->data)->active; i++)
    list = list->next;

  offset += (i * 16);

  ags_pattern_toggle_bit((AgsPattern *) drum->selected_pad->selected_line->channel->pattern->data, index0, index1, offset);

  return(0);
}

int
ags_drum_offset_callback(GtkWidget *widget, AgsDrum *drum)
{
  ags_drum_set_pattern(drum);
}

void
ags_drum_set_pattern(AgsDrum *drum)
{
  GList *list;
  guint index0, index1, offset;
  guint i;

  if(drum->selected_pad == NULL || drum->selected_pad->selected_line == NULL){
    printf("no selected pad or line\n\0");
    return;
  }

  for(i = 0; i < 4 && drum->selected0 != drum->index0[i]; i++);

  index0 = i;

  for(i = 0; i < 12 && drum->selected1 != drum->index1[i]; i++);
  
  index1 = i;

  list = gtk_container_get_children((GtkContainer *) drum->offset);

  for(i = 0; i < 4 && ! GTK_TOGGLE_BUTTON(list->data)->active; i++)
    list = list->next;

  offset = i * 16;

  list = gtk_container_get_children((GtkContainer *) drum->pattern);

  //  drum->flags = drum->flags | AGS_DRUM_BLOCK_PATTERN;
  drum->block_pattern = TRUE;

  for(i = 0; i < 16; i++){
    if(ags_pattern_get_bit((AgsPattern *) drum->selected_pad->selected_line->channel->pattern->data, index0, index1, offset + i))
      gtk_toggle_button_set_active((GtkToggleButton *) list->data, TRUE);
    else
      gtk_toggle_button_set_active((GtkToggleButton *) list->data, FALSE);

    list = list->next;
  }

  //  drum->flags = drum->flags ^ AGS_DRUM_BLOCK_PATTERN;
  drum->block_pattern = FALSE;
}
