#ifndef __AGS_MATRIX_H__
#define __AGS_MATRIX_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>

#include "../ags_machine.h"

#include <gtk/gtktable.h>
#include <gtk/gtktogglebutton.h>
#include <gtk/gtkdrawingarea.h>
#include <gtk/gtkadjustment.h>

#define AGS_TYPE_MATRIX                (ags_matrix_get_type())
#define AGS_MATRIX(obj)                ((AgsMatrix*) G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_MATRIX, AgsMatrix))
#define AGS_MATRIX_CLASS(class)        ((AgsMatrixClass*) G_TYPE_CHECK_CLASS_CAST(class, AGS_TYPE_MATRIX, AgsMatrixClass))

typedef struct _AgsMatrix AgsMatrix;
typedef struct _AgsMatrixClass AgsMatrixClass;

struct _AgsMatrix
{
  AgsMachine machine;

  GtkTable *table;

  GtkToggleButton *selected;
  GtkToggleButton *index[9];

  GtkDrawingArea *drawing_area;

  GtkAdjustment *adjustment;
};

struct _AgsMatrixClass
{
  AgsMachineClass machine;
};

AgsMatrix* ags_matrix_new();

#endif /*__AGS_MATRIX_H__*/
