#include "ags_oscillator.h"
#include "ags_oscillator_callbacks.h"

GType ags_oscillator_get_type(void);
void ags_oscillator_class_init(AgsOscillatorClass *oscillator);
void ags_oscillator_init(AgsOscillator *oscillator);
void ags_oscillator_destroy(GtkObject *object);
void ags_oscillator_show(GtkWidget *widget);
void ags_oscillator_connect(AgsOscillator *oscillator);

extern void (*gtk_container_destroy)(GtkObject *object);
extern void (*gtk_widget_real_show)(GtkWidget *widget);

GType
ags_oscillator_get_type(void)
{
  static GType oscillator_type = 0;

  if (!oscillator_type){
    static const GtkTypeInfo oscillator_info = {
      "AgsOscillator\0",
      sizeof(AgsOscillator), /* base_init */
      sizeof(AgsOscillatorClass), /* base_finalize */
      (GtkClassInitFunc) ags_oscillator_class_init,
      (GtkObjectInitFunc) ags_oscillator_init,
      NULL, /* class_finalize */
      NULL, /* class_data */
      (GtkClassInitFunc) NULL,
    };

    oscillator_type = gtk_type_unique (GTK_TYPE_FRAME, &oscillator_info);
  }

  return (oscillator_type);
}

void
ags_oscillator_class_init(AgsOscillatorClass *oscillator)
{
}

void
ags_oscillator_init(AgsOscillator *oscillator)
{
  GtkTable *table;
  GtkOptionMenu *option;
  GtkMenu *menu;
  GtkSpinButton *spin_button;

  table = (GtkTable *) gtk_table_new(6, 2, FALSE);
  gtk_container_add((GtkContainer *) oscillator, (GtkWidget *) table);

  gtk_table_attach_defaults(table,
			    (GtkWidget *) gtk_label_new("wave\0"),
			    0, 1, 0, 1);

  option = (GtkOptionMenu *) gtk_option_menu_new();
  gtk_table_attach_defaults(table,
			    (GtkWidget *) option,
			    1, 2, 0, 1);

  menu = (GtkMenu *) gtk_menu_new();

  gtk_menu_shell_append((GtkMenuShell *) menu,
			gtk_menu_item_new_with_label("sin\0"));

  gtk_menu_shell_append((GtkMenuShell *) menu,
			gtk_menu_item_new_with_label("cos\0"));

  gtk_menu_shell_append((GtkMenuShell *) menu,
			gtk_menu_item_new_with_label("saw\0"));

  gtk_menu_shell_append((GtkMenuShell *) menu,
			gtk_menu_item_new_with_label("square\0"));

  gtk_menu_shell_append((GtkMenuShell *) menu,
			gtk_menu_item_new_with_label("triangle\0"));

  gtk_option_menu_set_menu(option, (GtkWidget *) menu);

  gtk_table_attach_defaults(table,
			    (GtkWidget *) gtk_label_new("phase\0"),
			    2, 3, 0, 1);
  spin_button = (GtkSpinButton *) gtk_spin_button_new_with_range(0.0, 10000.0, 1.0);
  spin_button->adjustment->value = 0.0;
  gtk_table_attach_defaults(table, (GtkWidget *) spin_button, 3, 4, 0, 1);

  gtk_table_attach_defaults(table,
			    (GtkWidget *) gtk_label_new("lenght\0"),
			    0, 1, 1, 2);
  spin_button = (GtkSpinButton *) gtk_spin_button_new_with_range(0.0, 10000.0, 1.0);
  spin_button->adjustment->value = 440.0;
  gtk_table_attach_defaults(table, (GtkWidget *) spin_button, 1, 2, 1, 2);

  gtk_table_attach_defaults(table,
			    (GtkWidget *) gtk_label_new("frequence\0"),
			    2, 3, 1, 2);
  spin_button = (GtkSpinButton *) gtk_spin_button_new_with_range(0.0, 10000.0, 1.0);
  spin_button->adjustment->value = 440.0;
  gtk_table_attach_defaults(table, (GtkWidget *) spin_button, 3, 4, 1, 2);


  gtk_table_attach_defaults(table,
			    (GtkWidget *) gtk_label_new("volume\0"),
			    4, 5, 1, 2);
  spin_button = (GtkSpinButton *) gtk_spin_button_new_with_range(0.0, 1.0, 0.1);
  spin_button->adjustment->value = 0.8;
  gtk_table_attach_defaults(table, (GtkWidget *) spin_button, 5, 6, 1, 2);
}

void
ags_oscillator_destroy(GtkObject *object)
{
  if(gtk_container_destroy)
    gtk_container_destroy(object);
}

void
ags_oscillator_show(GtkWidget *widget)
{
  if(gtk_widget_real_show)
    gtk_widget_real_show(widget);
}

void
ags_oscillator_connect(AgsOscillator *oscillator)
{
}

AgsOscillator*
ags_oscillator_new()
{
  AgsOscillator *oscillator;

  oscillator = (AgsOscillator *) g_object_new(AGS_TYPE_OSCILLATOR, NULL);

  return(oscillator);
}
