#ifndef __AGS_AUDIO_H__
#define __AGS_AUDIO_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "ags_channel.h"

#define AGS_TYPE_AUDIO                (ags_audio_get_type())
#define AGS_AUDIO(obj)                ((AgsAudio*) G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_AUDIO, AgsAudio))
#define AGS_AUDIO_CLASS(class)        ((AgsAudioClass*) G_TYPE_CHECK_CLASS_CAST(class, AGS_TYPE_AUDIO, AgsAudioClass))
#define AGS_AUDIO_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS ((obj), AGS_TYPE_AUDIO, AgsAudioClass))

typedef struct _AgsAudio AgsAudio;
typedef struct _AgsAudioClass AgsAudioClass;

typedef enum{
  AGS_AUDIO_OUTPUT_HAS_RECYCLING,
  AGS_AUDIO_INPUT_HAS_RECYCLING,
}AgsAudioFlags;

struct _AgsAudio
{
  GObject object;

  guint flags;

  GObject *devout;

  guint sequence_lenght;
  guint audio_channels;

  guint output_pads;
  guint output_lines;

  guint input_pads;
  guint input_lines;

  AgsChannel *output;
  AgsChannel *input;

  GtkWidget *machine;
};

struct _AgsAudioClass
{
  GObjectClass object;

  void (*set_audio_channels)(AgsAudio *audio, guint audio_channels);
  void (*set_pads)(AgsAudio *audio, GType type, guint pads);
  void (*set_lines)(AgsAudio *audio, GType type, guint lines);
};

#define ags_audio_set_audio_channels(audio, audio_channels) AGS_AUDIO_GET_CLASS(audio)->set_audio_channels(audio, audio_channels)
#define ags_audio_set_pads(audio, type, pads) AGS_AUDIO_GET_CLASS(audio)->set_pads(audio, type, pads)
#define ags_audio_set_lines(audio, type, lines) AGS_AUDIO_GET_CLASS(audio)->set_lines(audio, type, lines)

AgsAudio* ags_audio_new();

#endif /*__AGS_AUDIO_H__*/
