#ifndef __AGS_CHANNEL_H__
#define __AGS_CHANNEL_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>

#include "ags_recall.h"
#include "ags_recycling.h"
#include "ags_notation.h"

#include "../file/ags_file.h"

#define AGS_TYPE_CHANNEL                (ags_channel_get_type())
#define AGS_CHANNEL(obj)                ((AgsChannel*) G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_CHANNEL, AgsChannel))
#define AGS_CHANNEL_CLASS(class)        ((AgsChannelClass*) G_TYPE_CHECK_CLASS_CAST(class, AGS_TYPE_CHANNEL, AgsChannelClass))
#define AGS_CHANNEL_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS((obj), AGS_TYPE_CHANNEL, AgsChannelClass))

typedef struct _AgsChannel AgsChannel;
typedef struct _AgsChannelClass AgsChannelClass;

struct _AgsChannel
{
  GObject object;

  guint flags;

  GObject *audio;

  AgsChannel *prev;
  AgsChannel *prev_pad;
  AgsChannel *next;
  AgsChannel *next_pad;

  guint pad;
  guint audio_channel;
  guint line;

  GList *recall;
  GList *task;

  AgsChannel *link;
  AgsRecycling *first_recycling;
  AgsRecycling *last_recycling;

  GList *pattern;
  AgsNotation *notation;

  GtkWidget *line_widget;
  gpointer file_data;
};

struct _AgsChannelClass
{
  GObjectClass object;

  void (*write_file)(AgsFile *file, AgsChannel *channel);
};

AgsRecall* ags_channel_find_recall(AgsChannel *channel, char *effect, char *name);

AgsChannel* ags_channel_last(AgsChannel *channel);
AgsChannel* ags_channel_nth(AgsChannel *channel, guint nth);

void ags_channel_set_link(AgsChannel *channel, AgsChannel *link);

AgsChannel* ags_channel_new();

#endif /*__AGS_CHANNEL_H__*/
