#include "ags_devout.h"

GType ags_devout_get_type();
void ags_devout_class_init (AgsDevoutClass *devout_class);
void ags_devout_init (AgsDevout *devout);
void ags_devout_destroy (GObject *gobject);

GType
ags_devout_get_type (void)
{
  static GType ags_type_devout = 0;

  if(!ags_type_devout){
    static const GTypeInfo ags_devout_info = {
      sizeof (AgsDevoutClass),
      NULL, /* base_init */
      NULL, /* base_finalize */
      (GClassInitFunc) ags_devout_class_init,
      NULL, /* class_finalize */
      NULL, /* class_data */
      sizeof (AgsDevout),
      0,    /* n_preallocs */
      (GInstanceInitFunc) ags_devout_init,
    };
    ags_type_devout = g_type_register_static (G_TYPE_OBJECT, "AgsDevout\0", &ags_devout_info, 0);
  }
  return (ags_type_devout);
}

void
ags_devout_class_init(AgsDevoutClass *devout_class)
{
}

void
ags_devout_init(AgsDevout *devout)
{
  devout->audio_channels = 0;
  devout->buffer_size = 0;

  devout->counter = g_object_new(AGS_TYPE_COUNTER, NULL);
  devout->current_lock = g_object_new(AGS_TYPE_COUNTER, NULL);
  devout->lock_counter = g_object_new(AGS_TYPE_COUNTER, NULL);

  devout->method = NULL;
  devout->device = NULL;
}

void
ags_devout_destroy(GObject *gobject)
{
  g_object_unref (gobject);
}

AgsDevout*
ags_devout_new()
{
  AgsDevout *devout;

  devout = (AgsDevout *) g_object_new(AGS_TYPE_DEVOUT, NULL);

  return(devout);
}
