#ifndef __AGS_DEVOUT_H__
#define __AGS_DEVOUT_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <ao/ao.h>

#include "time/ags_timer.h"
#include "time/ags_counter.h"

#define AGS_TYPE_DEVOUT                (ags_devout_get_type())
#define AGS_DEVOUT(obj)                ((AgsDevout*) G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_DEVOUT))
#define AGS_DEVOUT_CLASS(class)        ((AgsDevoutClass*) G_TYPE_CHECK_CLASS_CAST(class, AGS_TYPE_DEVOUT))

typedef struct _AgsDevout AgsDevout;
typedef struct _AgsDevoutClass AgsDevoutClass;

typedef enum
{
  AGS_DEVOUT_TROUGHPUT, // stay in realtime allow to drop recalls
}AgsDevoutFlags;

struct _AgsDevout
{
  GObject object;

  guint flags;

  guint audio_channels;
  guint buffer_size;

  AgsTimer *timer; // for timed tasks in AgsChannel
  AgsCounter *current_lock; // counts from 0 up to AGS_STREAM_LOCK_SIZE, then it resets to 0
  AgsCounter *lock_counter; // timer->counter->offset + AGS_STREAM_LOCK_SIZE

  union _AgsBuffer{
    char *buffer_char;
    guint *buffer_uint;
    float *buffer_float;
  }buffer;

  union _AgsOut{
    int device_fd;
    ao_device *device_ao;
  };

  char *method;
  char *device;
};

struct _AgsDevoutClass
{
  GObjectClass object;
};

AgsDevout* ags_devout_new();

#endif /*__AGS_DEVOUT_H__*/
