#include "ags_input.h"

GType ags_input_get_type();
void ags_input_class_init (AgsInputClass *input_class);
void ags_input_init (AgsInput *input);
void ags_input_destroy (GObject *gobject);

extern void ags_file_write_input(AgsFile *file, AgsChannel *channel);

GType
ags_input_get_type (void)
{
  static GType ags_type_input = 0;

  if(!ags_type_input){
    static const GTypeInfo ags_input_info = {
      sizeof (AgsInputClass),
      (GBaseInitFunc) NULL, /* base_init */
      (GBaseFinalizeFunc) NULL, /* base_finalize */
      (GClassInitFunc) ags_input_class_init,
      NULL, /* class_finalize */
      NULL, /* class_data */
      sizeof (AgsInput),
      0,    /* n_preallocs */
      (GInstanceInitFunc) ags_input_init,
    };
    ags_type_input = g_type_register_static (AGS_TYPE_CHANNEL, "AgsInput\0", &ags_input_info, 0);
  }
  return (ags_type_input);
}

void
ags_input_class_init(AgsInputClass *input)
{
  AgsChannelClass *channel = (AgsChannelClass *) input;

  channel->write_file = ags_file_write_input;
}

void
ags_input_init(AgsInput *input)
{
  input->file = NULL;
}

void
ags_input_destroy(GObject *gobject)
{
  ags_channel_destroy(gobject);
}

void
ags_input_set_file(AgsInput *input, char *file)
{
  input->file = file;
}

AgsInput*
ags_input_new()
{
  AgsInput *input;

  input = (AgsInput *) g_object_new(AGS_TYPE_INPUT, NULL);

  return(input);
}
