#include "ags_output.h"

GType ags_output_get_type();
void ags_output_class_init (AgsOutputClass *output_class);
void ags_output_init (AgsOutput *output);
void ags_output_destroy (GObject *gobject);

extern void ags_file_write_output(AgsFile *file, AgsChannel *channel);

GType
ags_output_get_type (void)
{
  static GType ags_type_output = 0;

  if(!ags_type_output){
    static const GTypeInfo ags_output_info = {
      sizeof (AgsOutputClass),
      (GBaseInitFunc) NULL, /* base_init */
      (GBaseFinalizeFunc) NULL, /* base_finalize */
      (GClassInitFunc) ags_output_class_init,
      NULL, /* class_finalize */
      NULL, /* class_data */
      sizeof (AgsOutput),
      0,    /* n_preallocs */
      (GInstanceInitFunc) ags_output_init,
    };
    ags_type_output = g_type_register_static(AGS_TYPE_CHANNEL, "AgsOutput\0", &ags_output_info, 0);
  }
  return (ags_type_output);
}

void
ags_output_class_init(AgsOutputClass *output)
{
  AgsChannelClass *channel = (AgsChannelClass *) output;

  channel->write_file = ags_file_write_output;
}

void
ags_output_init(AgsOutput *output)
{
}

void
ags_output_destroy(GObject *gobject)
{
  ags_channel_destroy(gobject);
}

AgsOutput*
ags_output_new()
{
  AgsOutput *output;

  output = (AgsOutput *) g_object_new(AGS_TYPE_OUTPUT, NULL);

  return(output);
}
