#ifndef __AGS_RECALL_H__
#define __AGS_RECALL_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>

#include "time/ags_offset.h"

#define AGS_TYPE_RECALL                (ags_recall_get_type())
#define AGS_RECALL(obj)                ((AgsRecall*) G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_RECALL, AgsRecall))
#define AGS_RECALL_CLASS(class)        ((AgsRecallClass*) G_TYPE_CHECK_CLASS_CAST(class, AGS_TYPE_RECALL, AgsRecallClass))

typedef struct _AgsRecall AgsRecall;
typedef struct _AgsRecallClass AgsRecallClass;

struct _AgsRecall
{
  GObject object;

  char *effect;
  char *name;

  AgsOffset *offset;

  guint control_count;
  gpointer *control;
};

struct _AgsRecallClass
{
  GObjectClass object;

  void (*run)(AgsRecall *recall);
  void (*stop)(AgsRecall *recall);

  AgsOffset* (*get_duration)(AgsRecall *recall);
};

void ags_recall_set_effect(AgsRecall *recall, char *effect);

AgsRecall* ags_recall_new();

#endif /*__AGS_RECALL_H__*/
