#include "ags_recycling.h"

GType ags_recycling_get_type();
void ags_recycling_class_init(AgsRecyclingClass *recycling_class);
void ags_recycling_init(AgsRecycling *recycling);
void ags_recycling_destroy(GObject *gobject);
void _ags_recycling_add_audio_signal(AgsRecycling *recycling);
void _ags_recycling_remove_audio_signal(AgsRecycling *recycling);

GType
ags_recycling_get_type (void)
{
  static GType ags_type_recycling = 0;

  if(!ags_type_recycling){
    static const GTypeInfo ags_recycling_info = {
      sizeof (AgsRecyclingClass),
      NULL, /* base_init */
      NULL, /* base_finalize */
      (GClassInitFunc) ags_recycling_class_init,
      NULL, /* class_finalize */
      NULL, /* class_data */
      sizeof (AgsRecycling),
      0,    /* n_preallocs */
      (GInstanceInitFunc) ags_recycling_init,
    };
    ags_type_recycling = g_type_register_static(G_TYPE_OBJECT, "AgsRecycling\0", &ags_recycling_info, 0);
  }
  return (ags_type_recycling);
}

void
ags_recycling_class_init(AgsRecyclingClass *recycling)
{
  recycling->add_audio_signal = _ags_recycling_remove_audio_signal;
  recycling->remove_audio_signal = _ags_recycling_add_audio_signal;
}

void
ags_recycling_init(AgsRecycling *recycling)
{
  recycling->next = NULL;
  recycling->prev = NULL;

  recycling->channel = NULL;

  recycling->audio_signal = NULL;
}

void
ags_recycling_destroy(GObject *gobject)
{
  g_object_unref (gobject);
}

void
_ags_recycling_add_audio_signal(AgsRecycling *recycling)
{
}

void
_ags_recycling_remove_audio_signal(AgsRecycling *recycling)
{
}

AgsRecycling*
ags_recycling_new()
{
  AgsRecycling *recycling;

  recycling = (AgsRecycling *) g_object_new(AGS_TYPE_RECYCLING, NULL);

  return(recycling);
}
