#ifndef __AGS_RECYCLING_H__
#define __AGS_RECYCLING_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/glist.h>

#define AGS_TYPE_RECYCLING                (ags_recycling_get_type())
#define AGS_RECYCLING(obj)                ((AgsRecycling*) G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_RECYCLING, AgsRecycling))
#define AGS_RECYCLING_CLASS(class)        ((AgsRecyclingClass*) G_TYPE_CHECK_CLASS_CAST(class, AGS_TYPE_RECYCLING, AgsRecyclingClass))
#define AGS_RECYCLING_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS ((obj), AGS_TYPE_RECYCLING, AgsRecyclingClass))

typedef struct _AgsRecycling AgsRecycling;
typedef struct _AgsRecyclingClass AgsRecyclingClass;

struct _AgsRecycling
{
  GObject object;

  AgsRecycling *next;
  AgsRecycling *prev;

  GObject *channel;

  GList *audio_signal;
};

struct _AgsRecyclingClass
{
  GObjectClass object;

  void (*add_audio_signal)(AgsRecycling *recycling);
  void (*remove_audio_signal)(AgsRecycling *recycling);
};

#define ags_recycling_add_audio_signal(recycling) AGS_RECYCLING_GET_CLASS(recycling)->add_audio_signal(recycling)
#define ags_recycling_remove_audio_signal(recycling) AGS_RECYCLING_GET_CLASS(recycling)->remove_audio_signal(recycling)

AgsRecycling* ags_recycling_new();

#endif /*__AGS_RECYCLING_H__*/
