#ifndef __AGS_TASK_H__
#define __AGS_TASK_H__

#include <glib.h>
#include <glib-object.h>

#define AGS_TYPE_TASK                (ags_task_get_type())
#define AGS_TASK(obj)                ((AgsTask*) G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_TASK))
#define AGS_TASK_CLASS(class)        ((AgsTaskClass*) G_TYPE_CHECK_CLASS_CAST(class, AGS_TYPE_TASK))

typedef struct _AgsTask AgsTask;
typedef struct _AgsTaskClass AgsTaskClass;

typedef enum{
  AGS_TASK_DO_OFFSET_PASSED, // 
  AGS_TASK_OFFSET_BASE_IS_ENTRY_POINT, // only usable when timer allows 
}AgsTaskFlags;

struct _AgsTask
{
  GObject object;

  guint flags;

  AgsChannel *channel;
  AgsOffset *offset; // where in AgsTaskClass start should be called
};

struct _AgsTaskClass
{
  GObjectClass object;

  void (*start)(AgsTask *task);
};

AgsTask* ags_task_new();

#endif /*__AGS_TASK_H__*/
