#include "ags_counter.h"

GType ags_counter_get_type();
void ags_counter_class_init(AgsCounterClass *counter);
void ags_counter_init(AgsCounter *counter);
void ags_counter_destroy(AgsCounter *counter);
void _ags_counter_increase(AgsCounter *counter);
void _ags_counter_decrease(AgsCounter *counter);
void _ags_counter_set(AgsCounter *counter, AgsOffset *offset);
void _ags_counter_out_of_time(AgsCounter *counter);
void _ags_counter_out_of_ressource(AgsCounter *counter);

GType
ags_counter_get_type()
{
  static GType ags_counter_type = 0;

  if(!ags_counter_type){
    static const GTypeInfo ags_counter_info = {
      "AgsCounter\0"
      sizeof(AgsCounterClass),
      NULL,
      NULL,
      (GClassInitFunc) ags_counter_class_init,
      NULL,
      NULL,
      sizeof(AgsCounter),
      0,
      (GInstanceInitFunc) ags_counter_init,
    };
  };

  return(ags_counter_type);
}

void
ags_counter_class_init(AgsCounterClass *counter)
{
  counter->increase = _ags_counter_increase;
  counter->decrease = _ags_counter_decrease;
  counter->set = _ags_counter_set;

  counter->out_of_time = _ags_counter_out_of_time;
  counter->out_of_ressource = _ags_counter_out_of_ressource;
}

void
ags_counter_init(AgsCounter *counter)
{
  counter->flags = 0;

  counter->offset.offset_uint.offset = 0;
}

void
ags_counter_destroy(AgsCounter *counter)
{
}

void
_ags_counter_increase(AgsCounter *counter)
{
}

void
_ags_counter_decrease(AgsCounter *counter)
{
}

void
_ags_counter_set(AgsCounter *counter, AgsOffset *offset)
{
}

void
_ags_counter_out_of_time(AgsCounter *counter)
{
}

void
_ags_counter_out_of_ressource(AgsCounter *counter)
{
}

void
ags_counter_check_ressource(AgsCounter *counter)
{
  if(AGS_OFFSET_CLONE & counter->offset.flags)
    if(AGS_OFFSET_LIST & counter->offset.flags){
      while(){
	if()
	  return(FALSE);
      }

	return(TRUE);
    }else{
      if()
      return(TRUE);
    }
  else if(AGS_OFFSET_UINT & counter->offset.flags)
    if(counter->offset.offset_entry.offset_uint.offset == ~0)
      return(TRUE);
  else if()
      return(TRUE);

  return(FALSE);
}

AgsCounter*
ags_counter_new()
{
  AgsCounter *counter;

  counter = (AgsCounter *) g_object_new(AGS_TYPE_COUNTER, NULL);

  return(counter);
}
