#ifndef __AGS_COUNTER_H__
#define __AGS_COUNTER_H__

#include <glib.h>
#include <glib-object.h>

#include "ags_offset.h"

#define AGS_COUNTER_TYPE           (ags_counter_get_type())
#define AGS_COUNTER(obj)           (G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_COUNTER_TYPE, AgsCounter))
#define AGS_COUNTER_CLASS(class)   (G_TYPE_CHECK_CLASS_CAST(class, AGS_COUNTER_TYPE, AgsCounterClass))
#define AGS_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS(obj, AGS_COUNTER_TYPE, AgsCounter))

typedef struct _AgsCounter AgsCounter;
typedef struct _AgsCounterClass AgsCounterClass;

typedef enum{
  //  AGS_COUNTER_OUT_OF_RESOURCE_TASK,
  AGS_COUNTER_CHECK_RESOURCE, // enables an AgsTask needed when  ounter_class->out_of_resoure is used
}AgsCounterFlags;

struct _AgsCounter
{
  GObject object;

  guint flags;

  GObject *audio_signal;
  AgsOffset *offset;
};

struct _AgsCounterClass
{
  GObjectClass object;

  void (*increase)(AgsCounter *counter);
  void (*decrease)(AgsCounter *counter);
  void (*set)(AgsCounter *counter, AgsOffset *offset);

  void (*out_of_time)(AgsCounter *counter); // used to call functions to destroy structs that should be used in the future, 
  void (*out_of_resource)(AgsCounter *counter); // called when maximum_size has been reached
};

AgsCounter* ags_counter_new();

#endif /*__AGS_COUNTER_H__*/
