#include "ags_offset.h"

GType ags_offset_get_type();
void ags_offset_init(AgsOffset *offset);

GType
ags_offset_get_type()
{
  static GType ags_type_offset = 0;

  if(!ags_type_offset){
    static const GTypeInfo ags_offset_info = {
      sizeof (AgsOffsetClass),
      NULL, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      sizeof (AgsOffset),
      0,    /* n_preallocs */
      (GInstanceInitFunc) ags_offset_init,
    };
    ags_type_offset = g_type_register_static(G_TYPE_OBJECT, "AgsOffset\0", &ags_offset_info, 0);
  }
  return (ags_type_offset);
}

void
ags_offset_init(AgsOffset *offset)
{
  offset->flags = 0;
}

gboolean
ags_offset_equal(AgsOffset *offset0, AgsOffset *offset1)
{
  gboolean value;
  guint ags_offset_equal_raw_to_base(guint a, guint b0, guint b1, gboolean keep){
    guint current_bit, stop_bit;
    gboolean ax, bx0, bx1;

    current_bit = 1;
    stop_bit = 1 << (sizeof(uint) * 8 -1);
    goto ags_offset_equal_raw_to_base0;
  
    do{
      current_bit = current_bit << 1;
    ags_offset_equal_raw_to_base0:

      ax = (current_bit & a) ? TRUE: FALSE;
      bx0 = (current_bit & b0) ? TRUE: FALSE;
      bx1 = (current_bit & b1) ? TRUE: FALSE;

      if(bx0){
	if(bx1){
	  if(keep){
	    if(!ax)
	      return(FALSE);
	  }else if(ax){
	    return(FALSE);
	  }else
	    keep = TRUE;
	}else if(keep){
	  if(ax)
	    return(FALSE);
	}else if(!ax)
	  return(FALSE);
      }else if(bx1){
	if(keep){
	  if(ax)
	    return(FALSE);
	}else if(!ax)
	  return(FALSE);
      }else if(keep)
	if(!ax)
	  return(FALSE);
	else
	  keep = FALSE;
      else if(ax)
	return(FALSE);

    }while(!(current_bit & stop_bit));

    return(TRUE | (keep << 1));
  }
  guint ags_offset_equal_base_to_base(guint a0, guint a1, gboolean a_keep, guint b0, guint b1, gboolean b_keep){
    guint current_bit, stop_bit;
    gboolean ax, bx;
    void ags_offset_equal_base_to_base_addition(){
      gboolean ax0, ax1, bx0, bx1;
#define AGS_OFFSET_EQUAL_BASE_TO_BASE_ADDITION(bit0, bit1, keep, bit_value) \
      if(bit0){	\
	if(bit1){ \
	  if(keep) \
	    bit_value = TRUE; \
	  else \
	    bit_value = FALSE; \
	}else if(keep) \
	  bit_value = FALSE; \
      }else if(bit1){ \
	if(keep) \
	  bit_value = FALSE; \
	else \
	  bit_value = TRUE; \
      }else if(keep){ \
	bit_value = TRUE; \
	keep = FALSE; \
      } \


      ax0 = (current_bit & a0) ? TRUE: FALSE;
      ax1 = (current_bit & a1) ? TRUE: FALSE;
      AGS_OFFSET_EQUAL_BASE_TO_BASE_ADDITION(ax0, ax1, a_keep, ax);

      bx0 = current_bit & b0;
      bx1 = current_bit & b1;
      AGS_OFFSET_EQUAL_BASE_TO_BASE_ADDITION(bx0, bx1, b_keep, bx);
    }

    current_bit = 1;
    stop_bit = 1 << (sizeof(uint) * 8 -1);
    goto ags_offset_equal_raw_to_base0;
  
    do{
      current_bit = current_bit << 1;
    ags_offset_equal_raw_to_base0:

      ags_offset_equal_base_to_base_addition();

      if(!(ax && bx) || !(!ax && !bx))
	return(FALSE);
    }while(!(current_bit & stop_bit));

    return(TRUE | (a_keep << 1) | (b_keep << 2));
  }
  gboolean ags_offset_equal_uint_to_list(AgsOffsetUInt *offset0, AgsOffsetList *offset1){
    if(offset0->offset != GPOINTER_TO_UINT(offset1->offset.data) ||
       offset1->offset.prev != NULL)
      return(FALSE);

    return(TRUE);
  }
  gboolean ags_offset_equal_uint_to_uint_frame(AgsOffsetUInt *offset0, AgsOffsetUIntFrame *offset1){
    if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset1)->flags){
      if(offset1->base != NULL){
	if(offset1->base->prev != NULL)
	  return(FALSE);
	else{
	  value = ags_offset_equal_raw_to_base(offset0->offset, offset1->offset, GPOINTER_TO_UINT(offset1->base->offset->data), FALSE);

	  if(!value || !(1 & value))
	    return(FALSE);
	  else
	    return(TRUE);
	}
      }else
	return(((offset0->offset == offset1->offset) ? TRUE: FALSE));
    }else{
      if(offset0->offset != offset1->offset ||
	 (offset1->base != NULL &&
	  (offset1->base->offset.prev != NULL ||
	   GPOINTER_TO_UINT(offset1->base->offset.data) != 0)))
	return(FALSE);
      else      
	return(TRUE);
    }
  }
  gboolean ags_offset_equal_uint_to_list_frame(AgsOffsetUInt *offset0, AgsOffsetListFrame *offset1){
    if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset1)->flags){
      if(offset1->base != NULL){
	if(offset1->base->prev != NULL || offset1->offset.prev != NULL)
	  return(FALSE);
	else{
	  value = ags_offset_equal_raw_to_base(offset0->offset, GPOINTER_TO_UINT(offset1->offset.data), GPOINTER_TO_UINT(offset1->base->offset->data), FALSE);

	  if(!value || ((TRUE << 1) & value))
	    return(FALSE);
	  else
	    return(TRUE);
	}
      }else
	return((offset0->offset == GPOINTER_TO_UINT(offset1->offset->data)) ? TRUE: FALSE);
    }else{
      if(offset0->offset != GPOINTER_TO_UINT(offset1->offset.data) || 
	 (offset1->base != NULL &&
	  (offset1->base->offset.prev != NULL ||
	   GPOINTER_TO_UINT(offset1->base->offset.data) != 0)))
	return(FALSE);
      else
	return(TRUE);
    }
  }
  gboolean ags_offset_equal_list_to_list(AgsOffsetList *offset0, AgsOffsetList *offset1){
    GList *list0, *list1;

    list0 = &(offset0->offset);
    list1 = &(offset1->offset);

    while(list0 != NULL && list1 != NULL){
      if(GPOINTER_TO_UINT(list0->data) != GPOINTER_TO_UINT(list1->data))
	return(FALSE);

      list0 = list0->prev;
      list1 = list1->prev;
    }

    if(list0 != NULL || list1 != NULL)
      return(FALSE);
    else
      return(TRUE);
  }
  gboolean ags_offset_equal_list_to_uint_frame(AgsOffsetList *offset0, AgsOffsetUIntFrame *offset1){
    GList *list0, *list1;
    guint value;

    if(offset->base == NULL){
      return(ags_offset_equal_list_to_uint(offset0, (AgsOffsetUInt *) offset1));
    }else if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset1)->flags){
      list1 = &(offset1->base->offset);
    ags_offset_equal_list_to_uint_frame0:
      list0 = &(offset0->offset);

      do{
	value = ags_offset_equal_raw_to_base(GPOINTER_TO_UINT(list0->data), 0, GPOINTER_TO_UINT(list1->data), keep);

	if(!value)
	  return(FALSE);

	keep = ((TRUE << 1) & value) ? TRUE: FALSE;

	list0 = list0->prev;
	list1 = list1->prev;
      }while(keep && list0 != NULL && list1 != NULL);

      while(list0 != NULL && list1 != NULL){
	if(GPOINTER_TO_UINT(list0->data) != GPOINTER_TO_UINT(list1->data))
	  return(FALSE);

	list0 = list0->prev;
	list1 = list1->prev;
      }

      if(keep || list1 != NULL || list0 != NULL)
	return(FALSE);
      else
	return(TRUE);
    }else{
      AgsOffsetList *offset_list;

      offset_list = ags_offset_get_base_absolute((AgsOffset*) offset1);
      list1 = &(offset_list->offset);

      goto ags_offset_equal_list_to_uint_frame0;
    }
  }
  gboolean ags_offset_equal_list_to_list_frame(AgsOffsetList *offset0, AgsOffsetListFrame *offset1){
    GList *list0, *list1, *list2, *list;
    guint value;
    gboolean keep;

    if(offset1->base == NULL){
      return(ags_offset_equal_list_to_list(offset0, (AgsOffsetList *) offset1));
    }else if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset1)->flags){
      list1 = &(offset1->base->offset);
    ags_offset_equal_list_to_list_frame0:
      list0 = &(offset0->offset);
      list2 = &(offset1->list_frame.offset);
      list = NULL;
      keep = FALSE;

      while(list1 != NULL || list2 != NULL){
	if(list0 == NULL)
	  return(FALSE);

	value = ags_offset_equal_raw_to_base(GPOINTER_TO_UINT(list0->data), GPOINTER_TO_UINT(list1->data), GPOINTER_TO_UINT(list2->data), keep);

	if(!value)
	  return(FALSE);

	keep = ((TRUE << 1) & value) ? TRUE: FALSE;

	list0 = list0->prev;
	list1 = list1->prev;
	list2 = list2->prev;
      }

      if(list1 == NULL){
	if(list2 == NULL){
	  if(list0 != NULL)
	    return(FALSE);
	}else
	  list = list1;
      }else
	list = list2;

      while(list != NULL){
	if(list0 == NULL)
	  return(FALSE);

	value = ags_offset_equal_raw_to_base(GPOINTER_TO_UINT(list0->data), GPOINTER_TO_UINT(list->data), 0, keep);

	if(!value)
	  return(FALSE);

	keep = ((TRUE << 1) & value) ? TRUE: FALSE;

	list0 = list0->prev;
	list = list->prev;
      }

      /* look at ags_offset_equal_uint_frame_to_list_frame for better readable code - may be changed __niy__ */
      if(list0 != NULL)
	if(keep){
	  value = ags_offset_equal_raw_to_base(GPOINTER_TO_UINT(list0->data), GPOINTER_TO_UINT(list->data), 0, keep);

	  if(!value)
	    return(FALSE);

	  keep = ((TRUE << 1) & value) ? TRUE: FALSE;
	}else
	  return(FALSE);
      else if(list != NULL || keep)
	return(FALSE);
      else
	return(TRUE);
    }else{
      AgsOffsetList *offset_list;

      offset = ags_offset_get_base_absolute((AgsOffset*) offset1);
      list1 = &(offset_list->offset);

      goto ags_offset_equal_list_to_list_frame0;
    }
  }
  gboolean ags_offset_equal_uint_frame_to_uint_frame(AgsOffsetUIntFrame *offset0, AgsOffsetUIntFrame *offset1){
    AgsOffsetList *offset_list;
    GList *list0, *list1;

    if(offset0->base == NULL){
      if(offset1->base == NULL){
	if(offset0->offset == offset1->offset)
	  return(TRUE);
	else
	  return(FALSE);
      }else{
      ags_offset_equal_uint_frame_to_uint_frame0:
	list1 = offset1->base.offset;

	if(list1->prev != NULL | (!(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset1)->flags) && GPOINTER_TO_UINT(list1->data) != 0))
	  return(FALSE);
	else{
	  guint value;

	  value = ags_offset_equal_raw_to_base(offset0->offset, offset1->offset, GPOINTER_TO_UINT(list1->data), FALSE);

	  if(!value || ((TRUE << 1) & value))
	    return(FALSE);
	  else
	    return(TRUE);
	}
      }
    }else if(offset1->base == NULL){
      AgsOffsetUIntFrame *offset_uint;

      offset_uint = offset0;
      offset0 = offset1;
      offset1 = offset_uint;

      goto ags_offset_equal_uint_frame_to_uint_frame0;
    }else if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset0)->flags){
      guint value;
      gboolean keep0, keep1;

      list0 = offset0->base->offset;

      if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset1)->flags)
	list1 = offset1->base->offset;
      else{
	offset = ags_offset_get_base_absolute((AgsOffset*) offset1);
	list1 = &(offset_list->offset);
      }

    ags_offset_equal_uint_frame_to_uint_frame1:
      value = ags_offset_equal_base_to_base(offset0->offset, GPOINTER_TO_UINT(list0->data), keep0, offset0->offset, GPOINTER_TO_UINT(list1->data), keep1);

      if(!value)
	return(FALSE);

      keep0 = ((TRUE << 1) & value);
      keep1 = ((TRUE << 2) & value);

      list0 = list0->prev;
      list1 = list1->prev;

      while(list0 != NULL && list1 != NULL && keep0 && keep1){
	value = ags_offset_equal_base_to_base(0, GPOINTER_TO_UINT(list0->data), keep0, 0, GPOINTER_TO_UINT(list1->data), keep1);

	if(!value)
	  return(FALSE);

	keep0 = ((TRUE << 1) & value);
	keep1 = ((TRUE << 2) & value);

	list0 = list0->prev;
	list1 = list1->prev;
      }

      if(keep0){
	while(list0 != NULL && list1 != NULL && keep0){
	  value = ags_offset_equal_base_to_raw(0, GPOINTER_TO_UINT(list0->data), keep0, GPOINTER_TO_UINT(list1->data));

	  if(!value)
	    return(FALSE);

	  keep0 = ((TRUE << 1) & value);

	  list0 = list0->prev;
	  list1 = list1->prev;
	}
      }else{
	while(list0 != NULL && list1 != NULL && keep1){
	  value = ags_offset_equal_raw_to_base(GPOINTER_TO_UINT(list0->data), 0, GPOINTER_TO_UINT(list1->data), keep1);

	  if(!value)
	    return(FALSE);

	  keep1 = ((TRUE << 2) & value);

	  list0 = list0->prev;
	  list1 = list1->prev;
	}
      }

      while(list0 != NULL && list1 != NULL){
	if(GPOINTER_TO_UINT(list0) != GPOINTER_TO_UINT(offset1))
	  return(FALSE);

	list0 = list0->prev;
	list1 = list1->prev;
      }

      if(list0 != NULL || list1 != NULL || keep0 != keep1)
	return(FALSE);
      else
	return(TRUE);
    }else if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset1)->flags){
      offset = ags_offset_get_base_absolute((AgsOffset*) offset0);
      list0 = &(offset_list->offset);

      goto ags_offset_equal_uint_frame_to_uint_frame1;
    }else{
      offset = ags_offset_get_base_absolute((AgsOffset*) offset0);
      list0 = &(offset_list->offset);

      offset = ags_offset_get_base_absolute((AgsOffset*) offset1);
      list1 = &(offset_list->offset);

      goto ags_offset_equal_uint_frame_to_uint_frame1;
    }
  }
  gboolean ags_offset_equal_uint_frame_to_list_frame(AgsOffsetUIntFrame *offset0, AgsOffsetListFrame *offset1){
    AgsOffsetList *offset_list;
    GList *list0, *list1, *list2;
    guint value;
    gboolean keep0, keep1;

    if(offset0->base == NULL)
      if(offset1->base == NULL){
	if(offset0->offset == GPOINTER_TO_UINT(offset1->offset.data) && offset1->offset.prev == NULL)
	  return(TRUE);
	else
	  return(FALSE);
      }else{
	if(offset1->offset.prev != NULL || offset1->base->offset.prev != NULL)
	  return(FALSE);

	if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset1)->flags){
	  list = &(offset1->offset);

	  value = ags_offset_equal_raw_to_base(offset0->offset, GPOINTER_TO_UINT(offset1->offset->data), GPOINTER_TO_UINT(offset1->offset->base->offset.data));

	  if(!value || ((TRUE << 1) & value))
	    return(FALSE);
	  else
	    return(TRUE);
	}else{
	  if(GPOINTER_TO_UINT(offset1->base->offset.data) != 0)
	    return(FALSE);
	  else if(offset0->offset == GPOINTER_TO_UINT(offset1->offset.data))
	    return(TRUE);
	  else
	    return(FALSE);
	}
      }
    else if(offset1->base == NULL){
      if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset0)->flags)
	list0 = &(offset0->base->offset);
      else{
	offset_list = ags_offset_get_base_absolute((AgsOffset*) offset0);
	list0 = &(offset_list->offset);
      }

      list1 = &(offset1->offset);

      value = ags_offset_equal_base_to_raw(offset0->offset, GPOINTER_TO_UINT(list0->data), keep0, GPOINTER_TO_UINT(list1->data));

      if(!value)
	return(FALSE);

      keep0 = ((TRUE << 1) & value) ? TRUE: FALSE;

	list0 = list0->prev;
	list1 = list1->prev;


      while(list0 != NULL && list1 != NULL && keep0){
	value = ags_offset_equal_base_to_raw(0, GPOINTER_TO_UINT(list0->data), keep0, GPOINTER_TO_UINT(list1->data));

	if(!value)
	  return(FALSE);

	keep0 = ((TRUE << 1) & value) ? TRUE: FALSE;

	list0 = list0->prev;
	list1 = list1->prev;
      }

      while(list0 != NULL && list1 != NULL){
	if(GPOINTER_TO_UINT(list0->data) != GPOINTER_TO_UINT(list1->data))
	  return(FALSE);

	list0 = list0->prev;
	list1 = list1->prev;
      }

      if(list0 != NULL || list1 != NULL || keep0)
	return(FALSE);
      else
	return(TRUE);
    }else if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset0)->flags){
      list0 = &(offset->base->offset);

      if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset1)->flags)
	list2 = &(offset1->base->offset);
      else{
	offset_list = ags_offset_get_base_absolute((AgsOffset*) offset1);
	list2 = &(offset_list->offset);
      }

      ags_offset_equal_uint_frame_to_list_frame0:
      list1 = &(offset1->offset);

      value = ags_offset_equal_base_to_base(offset0->offset, GPOINTER_TO_UINT(list0->data), FALSE, GPOINTER_TO_UINT(list1->data), GPOINTER_TO_UINT(list1->data), FALSE);

      if(!value)
	return(FALSE);

      keep0 = ((TRUE << 1) & value);
      keep1 = ((TRUE << 2) & value);

      list0 = list0->prev;
      list1 = list1->prev;
      list2 = list2->prev;

      while(list1 != NULL && list2 != NULL && keep0){
	if(list0 == NULL)
	  goto ags_offset_equal_uint_frame_to_list_frame_END;

	value = ags_offset_equal_base_to_base(0, GPOINTER_TO_UINT(list0->data), keep0, GPOINTER_TO_UINT(list1->data), GPOINTER_TO_UINT(list2->data), keep1);

	if(!value)
	  return(FALSE);

	keep0 = ((TRUE << 1) & value);
	keep1 = ((TRUE << 2) & value);

	list0 = list0->prev;
	list1 = list1->prev;
	list2 = list2->prev;
      }

      if(keep0 == FALSE){
	while(list1 != NULL && list2 != NULL){
	  if(list0 == NULL)
	    return(FALSE);

	  value = ags_offset_equal_raw_to_base(GPOINTER_TO_UINT(list0->data), GPOINTER_TO_UINT(list1->data), GPOINTER_TO_UINT(list2->data), keep1);

	  if(!value)
	    return(FALSE);

	  keep1 = ((TRUE << 2) & value) ? TRUE: FALSE;

	  list0 = list0->prev;
	  list1 = list1->prev;
	  list2 = list2->prev;
	}

	if(list1 == NULL)
	  list = list2;
	else
	  list = list1;

	while(list != NULL && keep1){
	  if(list0 == NULL)
	    return(FALSE);

	  value = ags_offset_equal_raw_to_base();

	  if(!value)
	    return(FALSE);

	  keep1 = ((TRUE << 2) & value) ? TRUE: FALSE;

	  list0 = list0->prev;
	  list = list->prev;
	}

	if(!keep1){
	  while(list0 == NULL && list == NULL){
	    if(GPOINTER_TO_UINT(list0->data) == GPOINTER_TO_UINT(list0->data))
	      return(FALSE);

	    list0 = list0->prev;
	    list = list->prev;
	  }

	  return(TRUE);
	}else
	  if(GPOINTER_TO_UINT(list0->data) > 1)
	    return(FALSE);
	  else
	    return(TRUE);
      }else{
	GList *list;

	if(list1 == NULL)
	  list = list2;
	else
	  list = list1;

	/* __niy__ check for keep survival and missing or correct tests on previous functions which uses ags_offset_equal_base_to_base */

	while(list != NULL && keep0 && keep1){
	  if(list0 == NULL)
	    goto ags_offset_equal_uint_frame_to_list_frame_END;

	  value = ags_offset_equal_base_to_base(0, GPOINTER_TO_UINT(list0->data), keep0, 0, GPOINTER_TO_UINT(list->data), keep1);

	  if(!value)
	    return(FALSE);

	  keep0 = ((TRUE << 1) & value) ? TRUE: FALSE;
	  keep1 = ((TRUE << 2) & value) ? TRUE: FALSE;

	  list0 = list0->prev;
	  list = list->prev;
	}

	if(!keep0){
	  while(list != NULL && keep1){
	    if(list0 == NULL)
	      return(FALSE);

	    value = ags_offset_equal_raw_to_base(GPOINTER_TO_UINT(list0->data), 0, GPOINTER_TO_UINT(list->data), keep1);

	    if(!value)
	      return(FALSE);

	    keep1 = ((TRUE << 2) & value) ? TRUE: FALSE;

	    list0 = list0->prev;
	    list = list->prev;
	  }

	  if(!keep1){
	    while(list0 != NULL && list != NULL){
	      if(GPOINTER_TO_UINT(list0->data) != GPOINTER_TO_UINT(list1->data))
		return(FALSE);

	      list0 = list0->prev;
	      list = list->prev;
	    }

	    if(list0 != NULL || list != NULL)
	      return(FALSE);
	    else
	      return(TRUE);
	  }else{
	    if(list0 != NULL){
	      if(!keep1 || list0->prev != NULL || GPOINTER_TO_UINT(list0->data) > 1)
		return(FALSE);
	      else
		return(TRUE);
	    }else if(list != NULL){
	      return(FALSE);
	    }else
	      if(keep1)
		return(FALSE);
	      else
		return(TRUE);
	  }
	}else if(!keep1){
	  while(list0 != NULL && list != NULL){
	    if(GPOINTER_TO_UINT(list0->data) != GPOINTER_TO_UINT(list->data))
	      return(FALSE);

	    list0 = list0->prev;
	    list = list->prev;
	  }

	  return(TRUE);
	}else{
	  if(list0 != NULL)
	    return(FALSE);
	  else
	    return(TRUE);
	}
      }

    ags_offset_equal_uint_frame_to_list_frame_END: /* correct misshandled keep */
      //#ifdef __AGS_OFFSET_OPTIMIZED_BY_SIZE__ /* code above for this option wasn't written yet __niy__ */
      //      if(list0 != NULL || ((!list_used && (list1 != NULL || list2 != NULL)) || list == NULL) || keep0 != keep1)
      //#endif
      if(list0 != NULL || list1 != NULL || list2 != NULL || keep0 != keep1)
	return(FALSE);
      else
	return(TRUE);
    }else if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset1)->flags){
      offset_list = ags_offset_get_base_absolute((AgsOffset *) offset0);
      list0 = &(offset_list->offset);

      list2 = &(offset1->base->offset);

      goto ags_offset_equal_uint_frame_to_list_frame0;
    }else{
      offset_list = ags_offset_get_base_absolute((AgsOffset *) offset0);
      list0 = &(offset_list->offset);

      offset_list = ags_offset_get_base_absolute((AgsOffset *) offset1);
      list2 = &(offset_list->offset);      

      goto ags_offset_equal_uint_frame_to_list_frame0;
    }
  }
  gboolean ags_offset_equal_list_frame_to_list_frame(AgsOffsetListFrame *offset0, AgsOffsetListFrame *offset1){
    AgsOffset *offset;
    GList *list0, *list1, *list2, *list3;
    GList *list_0, *list_1;

    /* check for simpler procedures in ags_offset_equal_uint_frame_to_list_frame */

    if(offset0->base == NULL){
      if(offset1->base == NULL){
	list_0 = &(offset0->offset);
	list_1 = &(offset1->offset);
	goto ags_offset_equal_list_frame_to_list_frame2;
      }else{
	list_0 = &(offset0->offset);
	list2 = &(offset1->offset);
	list3 = &(offset1->base);
	goto ags_offset_equal_list_frame_to_list_frame0;
      }
    }else if(offset1->base == NULL){
	list0 = &(offset0->offset);
	list1 = &(offset0->base);
	list_1 = &(offset1->offset);
	goto ags_offset_equal_list_frame_to_list_frame1;
    }else if(AGS_OFFSET_ABSOLUTE & offset0->flags){
      list1 = &(offset0->base->offset);

      if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset1)->flags)
	list3 = &(offset0->offset);
      else{
	offset = ags_offset_get_base_absolute((AgsOffset*) offset1);
	list3 = &(offset->offset_union.offset_list);
      }

    ags_offset_equal_list_frame_to_list_frame_DEFRAMIZE_post:
      list0 = &(offset0->offset);
      list2 = &(offset1->offset);

      while(TRUE){
	if(list0 == NULL){
	  list_0 = list1;
	  goto ags_offset_equal_list_frame_to_list_frame0;
	}else if(list1 == NULL){
	  list_0 = list0;
	  goto ags_offset_equal_list_frame_to_list_frame0;
	}else if(list2 == NULL){
	  list_1 = list3;
	  goto ags_offset_equal_list_frame_to_list_frame1;
	}else if(list3 == NULL){
	  list_1 = list2;
	  goto ags_offset_equal_list_frame_to_list_frame1;
	}

	value = ags_offset_equal_base_to_base(GPOINTER_TO_UINT(list0->data), GPOINTER_TO_UINT(list1->data), keep0, GPOINTER_TO_UINT(list2->data), GPOINTER_TO_UINT(list3->data), keep1);

	if(!value)
	  return(FALSE);

	keep0 = ((TRUE << 1) & value) ? TRUE: FALSE;
	keep1 = ((TRUE << 2) & value) ? TRUE: FALSE;

	list0 = list0->prev;
	list1 = list1->prev;
	list2 = list2->prev;
	list3 = list3->prev;
      }

    ags_offset_equal_list_frame_to_list_frame0:
      while(list_0 != NULL){
	if(list2 == NULL){
	  list_1 = list3;
	  goto ags_offset_equal_list_frame_to_list_frame1;
	}else if(list3 == NULL){
	  list_1 = list2;
	  goto ags_offset_equal_list_frame_to_list_frame1;
	}

	value = ags_offset_equal_base_to_raw(GPOINTER_TO_UINT(list0->data), GPOINTER_TO_UINT(list1->data), keep0, GPOINTER_TO_UINT(list_1->data));

	if(!value)
	  return(FALSE);

	keep0 = ((TRUE << 1) & value) ? TRUE: FALSE;

	list_0 = list_0->prev;
	list2 = list2->prev;
	list3 = list3->prev;
      }

    ags_offset_equal_list_frame_to_list_frame1:
      while(list_1 != NULL){
	if(list2 == NULL){
	  list_0 = list1;
	  goto ags_offset_equal_list_frame_to_list_frame0;
	}else if(list3 == NULL){
	  list_0 = list0;
	  goto ags_offset_equal_list_frame_to_list_frame0;
	}

	value = ags_offset_equal_raw_to_base(GPOINTER_TO_UINT(list_0->data), GPOINTER_TO_UINT(list2->data), GPOINTER_TO_UINT(list3->data), keep1);

	if(!value)
	  return(FALSE);

	keep1 = ((TRUE << 1) & value) ? TRUE: FALSE;

	list0 = list0->prev;
	list1 = list1->prev;
	list_1 = list_1->prev;
      }

    ags_offset_equal_list_frame_to_list_frame2:
      while(list_0 != NULL && list_1 != NULL){
	if(GPOINTER_TO_UINT(list_0->data) != GPOINTER_TO_UINT(list_1->data))
	  return(FALSE);

	list_0 = list_0->prev;
	list_1 = list_1->prev;
      }
    }else if(AGS_OFFSET_BASE_ABSOLUTE & AGS_OFFSET(offset1)->flags){
      offset = ags_offset_get_base_absolute((AgsOffset *) offset0);
      list1 = &(AGS_OFFSET_LIST(offset)->offset);

      goto ags_offset_equal_list_frame_to_list_frame_DEFRAMIZE_post;
    }else{
      offset = ags_offset_get_base_absolute((AgsOffset *) offset1);
      list1 = &(AGS_OFFSET_LIST(offset)->offset);

      offset = ags_offset_get_base_absolute((AgsOffset *) offset1);
      list3 = &(AGS_OFFSET_LIST(offset)->offset);

      goto ags_offset_equal_list_frame_to_list_frame_DEFRAMIZE_post;
    }

    return(TRUE);
  }

#define ags_offset_equal_offset_list_frame_double_struct_deframeize(frame, offset, offset_x, frame_size, frame_size_x, keep, value) /* (AgsOffsetListFrameDouble, GList, GList, uint current_bit, GList *, GList *solution) */ \
  if(bit & GPOINTER_TO_UINT(offset->data)){				\
  }									\

#define ags_offset_equal_uint_to_uint(offset0, offset1) ((offset0->offset == offset1->offset) ? TRUE: FALSE)

#define ags_offset_equal_list_to_uint(offset0, offset1) ags_offset_equal_uint_to_list(offset1, offset0)

#define ags_offset_equal_uint_frame_to_uint(offset0, offset1) ags_offset_equal_uint_to_uint_frame(offset1, offset1)
#define ags_offset_equal_uint_frame_to_list(offset0, offset1) ags_offset_equal_list_to_uint_frame(offset1, offset0)

#define ags_offset_equal_list_frame_to_uint(offset0, offset1) ags_offset_equal_uint_to_list_frame(offset1, offset0)
#define ags_offset_equal_list_frame_to_list(offset0, offset1) ags_offset_equal_list_frame_to_list(offset1, offset0)
#define ags_offset_equal_list_frame_to_uint_frame(offset0, offset1) ags_offset_equal_uint_frame_to_list_frame(offset1, offset0)

  value = FALSE;

  if(AGS_IS_OFFSET_UINT(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      value = ags_offset_equal_uint_to_uint((AgsOffsetUInt *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      value = ags_offset_equal_uint_to_list((AgsOffsetUInt *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      value = ags_offset_equal_uint_to_uint_frame((AgsOffsetUInt *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      value = ags_offset_equal_uint_to_list_frame((AgsOffsetUInt *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_equal type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_LIST(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      value = ags_offset_equal_list_to_uint((AgsOffsetList *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      value = ags_offset_equal_list_to_list((AgsOffsetList *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      value = ags_offset_equal_list_to_uint_frame((AgsOffsetList *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      value = ags_offset_equal_list_to_list_frame((AgsOffsetList *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_equal type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_UINT_FRAME(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      value = ags_offset_equal_uint_frame_to_uint((AgsOffsetUIntFrame *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      value = ags_offset_equal_uint_frame_to_list((AgsOffsetUIntFrame *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      value = ags_offset_equal_uint_frame_to_uint_frame((AgsOffsetUIntFrame *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      value = ags_offset_equal_uint_frame_to_list_frame((AgsOffsetUIntFrame *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_equal type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_LIST_FRAME(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      value = ags_offset_equal_list_frame_to_uint((AgsOffsetListFrame *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      value = ags_offset_equal_list_frame_to_list((AgsOffsetListFrame *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      value = ags_offset_equal_list_frame_to_uint_frame((AgsOffsetListFrame *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      value = ags_offset_equal_list_frame_to_list_frame((AgsOffsetListFrame *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_equal type is unknown or not implemented of offset1\n\0");
    }
#endif
  }
#ifdef __AGS_DEBUG__
  else{
    fprintf(stdout, "warning - ags_offset_equal type is unknown or not implemented of offset0\n\0");
  }
#endif

  return(value);
}

gboolean
ags_offset_less(AgsOffset *offset0, AgsOffset *offset1)
{
  AgsOffset *offset;
  gboolean value;
  gboolean ags_offset_less_uint_to_list(AgsOffsetUInt *offset0, AgsOffsetList *offset1){
    if(offset1->offset.prev != NULL || offset0->offset >= GPOINTER_TO_UINT(offset1->offset.data))
      return(FALSE);
    else
      return(TRUE);
  }
  gboolean ags_offset_less_uint_to_uint_frame(AgsOffsetUInt *offset0, AgsOffsetUIntFrame *offset1){
    AgsOffset *offset;

    offset = ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST);

    if(offset->offset.prev != NULL || offset0->offset >= GPOINTER_TO_UINT(offset->offset.data))
      return(FALSE);
    else
      return(TRUE);
  }
  gboolean ags_offset_less_uint_to_list_frame(AgsOffsetUInt *offset0, AgsOffsetListFrame *offset1){
    AgsOffset *offset;

    offset = ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST);

    if(offset->offset.prev != NULL || offset0->offset >= GPOINTER_TO_UINT(offset->offset.data))
      return(FALSE);
    else
      return(TRUE);
  }
  gboolean ags_offset_less_list_to_list(AgsOffsetList *offset0, AgsOffsetList *offset1){
    GList *list0, *list1;

    list0 = &(offset0->offset);
    list1 = &(offset1->offset);

    while(list0 != NULL && list1 != NULL){
      if(GPOINTER_TO_UINT(list0->data) != GPOINTER_TO_UINT(list1->data))
	return(FALSE);

      list0 = list0->next;
      list1 = list1->next;
    }

    return(TRUE);
  }

#define ags_offset_less_uint_to_uint(offset0, offset1) ((offset0->offset < offset1->offset) ? TRUE: FALSE)

#define ags_offset_less_list_to_uint(offset0, offset1) ags_offset_less_uint_to_list(offset1, offset0)

#define ags_offset_less_uint_frame_to_uint(offset0, offset1) ags_offset_less_uint_to_uint_frame(offset1, offset1)

#define ags_offset_less_list_to_uint_frame(offset0, offset1) ags_offset_less_list_to_list(offset0, ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST))
#define ags_offset_less_list_to_list_frame(offset0, offset1) ags_offset_less_list_to_list(offset0, ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST))
#define ags_offset_less_uint_frame_to_uint_frame(offset0, offset1) ags_offset_less_list_to_list(ags_offset_to_offset(offset0, AGS_TYPE_OFFSET_LIST), ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST))
#define ags_offset_less_uint_frame_to_list_frame(offset0, offset1) ags_offset_less_list_to_list(ags_offset_to_offset(offset0, AGS_TYPE_OFFSET_LIST), ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST))
#define ags_offset_less_list_frame_to_list_frame(offset0, offset1) ags_offset_less_list_to_list(ags_offset_to_offset(offset0, AGS_TYPE_OFFSET_LIST), ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST))

#define ags_offset_less_uint_frame_to_list(offset0, offset1) ags_offset_less_list_to_list(ags_offset_to_offset(offset0, AGS_TYPE_OFFSET_LIST), offset1)
#define ags_offset_less_list_frame_to_uint(offset0, offset1) ags_offset_less_uint_to_list_frame(offset1, offset0)
#define ags_offset_less_list_frame_to_list(offset0, offset1) ags_offset_less_list_to_list(ags_offset_to_offset(offset0, AGS_TYPE_OFFSET_LIST), offset1)
#define ags_offset_less_list_frame_to_uint_frame(offset0, offset1) ags_offset_less_list_to_list(ags_offset_to_offset(offset0, AGS_TYPE_OFFSET_LIST), ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST))

  value = FALSE;

  if(AGS_IS_OFFSET_UINT(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      value = ags_offset_less_uint_to_uint((AgsOffsetUInt *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      value = ags_offset_less_uint_to_list((AgsOffsetUInt *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      value = ags_offset_less_uint_to_uint_frame((AgsOffsetUInt *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      value = ags_offset_less_uint_to_list_frame((AgsOffsetUInt *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_less type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_LIST(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      value = ags_offset_less_list_to_uint((AgsOffsetList *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      value = ags_offset_less_list_to_list((AgsOffsetList *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      value = ags_offset_less_list_to_uint_frame((AgsOffsetList *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      value = ags_offset_less_list_to_list_frame((AgsOffsetList *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_less type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_UINT_FRAME(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      value = ags_offset_less_uint_frame_to_uint((AgsOffsetUIntFrame *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      value = ags_offset_less_uint_frame_to_list((AgsOffsetUIntFrame *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      value = ags_offset_less_uint_frame_to_uint_frame((AgsOffsetUIntFrame *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      value = ags_offset_less_uint_frame_to_list_frame((AgsOffsetUIntFrame *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_less type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_LIST_FRAME(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      value = ags_offset_less_list_frame_to_uint((AgsOffsetListFrame *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      value = ags_offset_less_list_frame_to_list((AgsOffsetListFrame *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      value = ags_offset_less_list_frame_to_uint_frame((AgsOffsetListFrame *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      value = ags_offset_less_list_frame_to_list_frame((AgsOffsetListFrame *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_less type is unknown or not implemented of offset1\n\0");
    }
#endif
  }
#ifdef __AGS_DEBUG__
  else{
    fprintf(stdout, "warning - ags_offset_less type is unknown or not implemented of offset0\n\0");
  }
#endif

  return(value);
}

gboolean
ags_offset_greater(AgsOffset *offset0, AgsOffset *offset1)
{
  gboolean value;
  AgsOffset *offset;
  gboolean value;
  gboolean ags_offset_greater_uint_to_list(AgsOffsetUInt *offset0, AgsOffsetList *offset1){
    if(offset1->offset.prev != NULL || offset0->offset <= GPOINTER_TO_UINT(offset1->offset.data))
      return(FALSE);
    else
      return(TRUE);
  }
  gboolean ags_offset_greater_uint_to_uint_frame(AgsOffsetUInt *offset0, AgsOffsetUIntFrame *offset1){
    AgsOffset *offset;

    offset = ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST);

    if(offset->offset.prev != NULL || offset0->offset <= GPOINTER_TO_UINT(offset->offset.data))
      return(FALSE);
    else
      return(TRUE);
  }
  gboolean ags_offset_greater_uint_to_list_frame(AgsOffsetUInt *offset0, AgsOffsetListFrame *offset1){
    AgsOffset *offset;

    offset = ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST);

    if(offset->offset.prev != NULL || offset0->offset <= GPOINTER_TO_UINT(offset->offset.data))
      return(FALSE);
    else
      return(TRUE);
  }
  gboolean ags_offset_greater_list_to_list(AgsOffsetList *offset0, AgsOffsetList *offset1){
    GList *list0, *list1;

    list0 = &(offset0->offset);
    list1 = &(offset1->offset);

    while(list0 != NULL && list1 != NULL){
      if(GPOINTER_TO_UINT(list0->data) != GPOINTER_TO_UINT(list1->data))
	return(FALSE);

      list0 = list0->next;
      list1 = list1->next;
    }

    return(TRUE);
  }

#define ags_offset_greater_uint_to_uint(offset0, offset1) ((offset0->offset > offset1->offset) ? TRUE: FALSE)

#define ags_offset_greater_list_to_uint(offset0, offset1) ags_offset_greater_uint_to_list(offset1, offset0)

#define ags_offset_greater_uint_frame_to_uint(offset0, offset1) ags_offset_greater_uint_to_uint_frame(offset1, offset1)

#define ags_offset_greater_list_frame_to_uint(offset0, offset1) ags_offset_greater_uint_to_list_frame(offset1, offset0)
#define ags_offset_greater_list_frame_to_list(offset0, offset1) ags_offset_greater_list_frame_to_list(offset1, offset0)
#define ags_offset_greater_list_frame_to_uint_frame(offset0, offset1) ags_offset_greater_uint_frame_to_list_frame(offset1, offset0)

#define ags_offset_greater_list_to_uint_frame(offset0, offset1) ags_offset_greater_list_to_list(offset0, ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST))
#define ags_offset_greater_list_to_list_frame(offset0, offset1) ags_offset_greater_list_to_list(offset0, ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST))
#define ags_offset_greater_uint_frame_to_uint_frame(offset0, offset1) ags_offset_greater_list_to_list(ags_offset_to_offset(offset0, AGS_TYPE_OFFSET_LIST), ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST))
#define ags_offset_greater_uint_frame_to_list_frame(offset0, offset1) ags_offset_greater_list_to_list(ags_offset_to_offset(offset0, AGS_TYPE_OFFSET_LIST), ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST))
#define ags_offset_greater_list_frame_to_list_frame(offset0, offset1) ags_offset_greater_list_to_list(ags_offset_to_offset(offset0, AGS_TYPE_OFFSET_LIST), ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST))

#define ags_offset_greater_uint_frame_to_list(offset0, offset1) ags_offset_greater_list_to_list(ags_offset_to_offset(offset0, AGS_TYPE_OFFSET_LIST), offset1)
#define ags_offset_greater_list_frame_to_uint(offset0, offset1) ags_offset_greater_uint_to_list_frame(offset1, offset0)
#define ags_offset_greater_list_frame_to_list(offset0, offset1) ags_offset_greater_list_to_list(ags_offset_to_offset(offset0, AGS_TYPE_OFFSET_LIST), offset1)
#define ags_offset_greater_list_frame_to_uint_frame(offset0, offset1) ags_offset_greater_list_to_list(ags_offset_to_offset(offset0, AGS_TYPE_OFFSET_LIST), ags_offset_to_offset(offset1, AGS_TYPE_OFFSET_LIST))

  value = FALSE;

  if(AGS_IS_OFFSET_UINT(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      value = ags_offset_greater_uint_to_uint((AgsOffsetUInt *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      value = ags_offset_greater_uint_to_list((AgsOffsetUInt *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      value = ags_offset_greater_uint_to_uint_frame((AgsOffsetUInt *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      value = ags_offset_greater_uint_to_list_frame((AgsOffsetUInt *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_greater type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_LIST(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      value = ags_offset_greater_list_to_uint((AgsOffsetList *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      value = ags_offset_greater_list_to_list((AgsOffsetList *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      value = ags_offset_greater_list_to_uint_frame((AgsOffsetList *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      value = ags_offset_greater_list_to_list_frame((AgsOffsetList *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_greater type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_UINT_FRAME(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      value = ags_offset_greater_uint_frame_to_uint((AgsOffsetUIntFrame *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      value = ags_offset_greater_uint_frame_to_list((AgsOffsetUIntFrame *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      value = ags_offset_greater_uint_frame_to_uint_frame((AgsOffsetUIntFrame *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      value = ags_offset_greater_uint_frame_to_list_frame((AgsOffsetUIntFrame *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_greater type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_LIST_FRAME(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      value = ags_offset_greater_list_frame_to_uint((AgsOffsetListFrame *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      value = ags_offset_greater_list_frame_to_list((AgsOffsetListFrame *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      value = ags_offset_greater_list_frame_to_uint_frame((AgsOffsetListFrame *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      value = ags_offset_greater_list_frame_to_list_frame((AgsOffsetListFrame *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_greater type is unknown or not implemented of offset1\n\0");
    }
#endif
  }
#ifdef __AGS_DEBUG__
  else{
    fprintf(stdout, "warning - ags_offset_greater type is unknown or not implemented of offset0\n\0");
  }
#endif

  return(value);
}

void
ags_offset_addition(AgsOffset *offset0, AgsOffset *offset1)
{
  void ags_offset_addition_uint_to_list(AgsOffsetUInt *offset0, AgsOffsetList *offset1){
  }
  void ags_offset_addition_uint_to_uint_frame(AgsOffsetUInt *offset0, AgsOffsetUIntFrame *offset1){
  }
  void ags_offset_addition_uint_to_list_frame(AgsOffsetUInt *offset0, AgsOffsetListFrame *offset1){
  }
  void ags_offset_addition_list_to_list(AgsOffsetList *offset0, AgsOffsetList *offset1){
  }
  void ags_offset_addition_list_to_uint_frame(AgsOffsetList *offset0, AgsOffsetUIntFrame *offset1){
  }
  void ags_offset_addition_list_to_list_frame(AgsOffsetList *offset0, AgsOffsetListFrame *offset1){
  }
  void ags_offset_addition_uint_frame_to_uint_frame(AgsOffsetUIntFrame *offset0, AgsOffsetUIntFrame *offset1){
  }
  void ags_offset_addition_uint_frame_to_list_frame(AgsOffsetUIntFrame *offset0, AgsOffsetListFrame *offset1){
  }
  void ags_offset_addition_list_frame_to_list_frame(AgsOffsetListFrame *offset0, AgsOffsetListFrame *offset1){
  }

#define ags_offset_addition_uint_to_uint(offset0, offset1) (offset0->offset += offset1->offset)

#define ags_offset_addition_list_to_uint(offset0, offset1) ags_offset_addition_uint_to_list(offset1, offset0)

#define ags_offset_addition_uint_frame_to_uint(offset0, offset1) ags_offset_addition_uint_to_uint_frame(offset1, offset1)
#define ags_offset_addition_uint_frame_to_list(offset0, offset1) ags_offset_addition_list_to_uint_frame(offset1, offset0)

#define ags_offset_addition_list_frame_to_uint(offset0, offset1) ags_offset_addition_uint_to_list_frame(offset1, offset0)
#define ags_offset_addition_list_frame_to_list(offset0, offset1) ags_offset_addition_list_frame_to_list(offset1, offset0)
#define ags_offset_addition_list_frame_to_uint_frame(offset0, offset1) ags_offset_addition_uint_frame_to_list_frame(offset1, offset0)


  if(AGS_IS_OFFSET_UINT(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      ags_offset_addition_uint_to_uint((AgsOffsetUInt *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      ags_offset_addition_uint_to_list((AgsOffsetUInt *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      ags_offset_addition_uint_to_uint_frame((AgsOffsetUInt *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      ags_offset_addition_uint_to_list_frame((AgsOffsetUInt *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_addition type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_LIST(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      ags_offset_addition_list_to_uint((AgsOffsetList *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      ags_offset_addition_list_to_list((AgsOffsetList *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      ags_offset_addition_list_to_uint_frame((AgsOffsetList *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      ags_offset_addition_list_to_list_frame((AgsOffsetList *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_addition type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_UINT_FRAME(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      ags_offset_addition_uint_frame_to_uint((AgsOffsetUIntFrame *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      ags_offset_addition_uint_frame_to_list((AgsOffsetUIntFrame *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      ags_offset_addition_uint_frame_to_uint_frame((AgsOffsetUIntFrame *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      ags_offset_addition_uint_frame_to_list_frame((AgsOffsetUIntFrame *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_addition type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_LIST_FRAME(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      ags_offset_addition_list_frame_to_uint((AgsOffsetListFrame *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      ags_offset_addition_list_frame_to_list((AgsOffsetListFrame *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      ags_offset_addition_list_frame_to_uint_frame((AgsOffsetListFrame *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      ags_offset_addition_list_frame_to_list_frame((AgsOffsetListFrame *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_addition type is unknown or not implemented of offset1\n\0");
    }
#endif
  }
#ifdef __AGS_DEBUG__
  else{
    fprintf(stdout, "warning - ags_offset_addition type is unknown or not implemented of offset0\n\0");
  }
#endif
}

void
ags_offset_subtraction(AgsOffset *offset0, AgsOffset *offset1)
{
  void ags_offset_subtraction_uint_to_list(AgsOffsetUInt *offset0, AgsOffsetList *offset1){
  }
  void ags_offset_subtraction_uint_to_uint_frame(AgsOffsetUInt *offset0, AgsOffsetUIntFrame *offset1){
  }
  void ags_offset_subtraction_uint_to_list_frame(AgsOffsetUInt *offset0, AgsOffsetListFrame *offset1){
  }
  void ags_offset_subtraction_list_to_list(AgsOffsetList *offset0, AgsOffsetList *offset1){
  }
  void ags_offset_subtraction_list_to_uint_frame(AgsOffsetList *offset0, AgsOffsetUIntFrame *offset1){
  }
  void ags_offset_subtraction_list_to_list_frame(AgsOffsetList *offset0, AgsOffsetListFrame *offset1){
  }
  void ags_offset_subtraction_uint_frame_to_uint_frame(AgsOffsetUIntFrame *offset0, AgsOffsetUIntFrame *offset1){
  }
  void ags_offset_subtraction_uint_frame_to_list_frame(AgsOffsetUIntFrame *offset0, AgsOffsetListFrame *offset1){
  }
  void ags_offset_subtraction_list_frame_to_list_frame(AgsOffsetListFrame *offset0, AgsOffsetListFrame *offset1){
  }

#define ags_offset_subtraction_uint_to_uint(offset0, offset1) (offset0->offset -= offset1->offset)

#define ags_offset_subtraction_list_to_uint(offset0, offset1) ags_offset_subtraction_uint_to_list(offset1, offset0)

#define ags_offset_subtraction_uint_frame_to_uint(offset0, offset1) ags_offset_subtraction_uint_to_uint_frame(offset1, offset1)
#define ags_offset_subtraction_uint_frame_to_list(offset0, offset1) ags_offset_subtraction_list_to_uint_frame(offset1, offset0)

#define ags_offset_subtraction_list_frame_to_uint(offset0, offset1) ags_offset_subtraction_uint_to_list_frame(offset1, offset0)
#define ags_offset_subtraction_list_frame_to_list(offset0, offset1) ags_offset_subtraction_list_frame_to_list(offset1, offset0)
#define ags_offset_subtraction_list_frame_to_uint_frame(offset0, offset1) ags_offset_subtraction_uint_frame_to_list_frame(offset1, offset0)

  if(AGS_IS_OFFSET_UINT(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      ags_offset_subtraction_uint_to_uint((AgsOffsetUInt *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      ags_offset_subtraction_uint_to_list((AgsOffsetUInt *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      ags_offset_subtraction_uint_to_uint_frame((AgsOffsetUInt *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      ags_offset_subtraction_uint_to_list_frame((AgsOffsetUInt *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_subtraction type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_LIST(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      ags_offset_subtraction_list_to_uint((AgsOffsetList *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      ags_offset_subtraction_list_to_list((AgsOffsetList *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      ags_offset_subtraction_list_to_uint_frame((AgsOffsetList *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      ags_offset_subtraction_list_to_list_frame((AgsOffsetList *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_subtraction type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_UINT_FRAME(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      ags_offset_subtraction_uint_frame_to_uint((AgsOffsetUIntFrame *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      ags_offset_subtraction_uint_frame_to_list((AgsOffsetUIntFrame *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      ags_offset_subtraction_uint_frame_to_uint_frame((AgsOffsetUIntFrame *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      ags_offset_subtraction_uint_frame_to_list_frame((AgsOffsetUIntFrame *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else{
      fprintf(stdout, "warning - ags_offset_subtraction type is unknown or not implemented of offset1\n\0");
    }
#endif
  }else if(AGS_IS_OFFSET_LIST_FRAME(offset0)){
    if(AGS_IS_OFFSET_UINT(offset1)){
      ags_offset_subtraction_list_frame_to_uint((AgsOffsetListFrame *) offset0, (AgsOffsetUInt *) offset1);
    }else if(AGS_IS_OFFSET_LIST(offset1)){
      ags_offset_subtraction_list_frame_to_list((AgsOffsetListFrame *) offset0, (AgsOffsetList *) offset1);
    }else if(AGS_IS_OFFSET_UINT_FRAME(offset1)){
      ags_offset_subtraction_list_frame_to_uint_frame((AgsOffsetListFrame *) offset0, (AgsOffsetUIntFrame *) offset1);
    }else if(AGS_IS_OFFSET_LIST_FRAME(offset1)){
      ags_offset_subtraction_list_frame_to_list_frame((AgsOffsetListFrame *) offset0, (AgsOffsetListFrame *) offset1);
    }
#ifdef __AGS_DEBUG__
    else
      fprintf(stdout, "warning - ags_offset_subtraction() type is unknown of offset1\n  skipped\n\0");
#endif
  }
#ifdef __AGS_DEBUG__
  else{
    fprintf(stdout, "warning - ags_offset_subtraction() type is unknown or not implemented of offset0\n\0");
  }
#endif
}

AgsOffsetList*
ags_offset_base_get_absolute(AgsOffset *base, AgsOffset *offset0)
{
  AgsOffset *offset1;

  offset1 = ags_offset_alloc(AGS_OFFSET_LIST);

  offset1->offset_union.offset_list.maximum_size = offset0->offset_union.offset_list.maximum_size;

  /*
   * not implemented yet
   */

  return(offset1);
}

AgsOffsetList*
ags_offset_get_base_absolute(AgsOffset *offset)
{
  static AgsOffsetList *offset_list0
  AgsOffsetList *offset_list1;

  offset_list0 = g_object_new(AGS_TYPE_OFFSET_LIST, NULL);

  offset_list0 = ags_offset_to_offset(offset, AGS_TYPE_OFFSET_LIST);
  base = ags_offset_addition(offset_list0, offset_list1);

  return(offset_list);
}

AgsOffset*
ags_offset_to_offset(AgsOffset *offset, GType type, GList *maximum_size, GList *frame_size, GList *base_count, ...)
{
  va_list arg0;
  GList *arg1;
  AgsOffset *maximum_size;

  arg1 = NULL;

  if(G_TYPE_FROM_INSTANCE(offset) == type){
    if(AGS_IS_OFFSET_UINT(offset))
      return(offset);
    else if(AGS_IS_OFFSET_LIST(offset)){
      if(maximum_size != NULL){
      }
    }else{
      va_start(arg0, base_count);

      maximum_size = (GList *) va_arg(arg0, (GList *));
      arg1 = g_list_alloc();
      arg1->data = (gpointer) data;

      if(arg1 != NULL){
	arg1->prev = NULL;
	arg1 = (GList*) g_list_alloc();

	while((data = va_arg(arg0, (GList *))) != NULL){
	  arg1->next = (GList*) g_list_alloc();
	  arg1->next->prev = arg1;
	  arg1 = arg1->next;
	  arg1->data = maximum_size;
	}

	arg1->next = NULL;
      }

      va_end(arg);
    }
  }

  if(AGS_IS_OFFSET_UINT(offset)){
    if(type == AGS_TYPE_LIST){

    }else if(type == AGS_TYPE_UINT_FRAME){

    }else if(type == AGS_TYPE_LIST_FRAME){

    }
  }else if(AGS_IS_OFFSET_LIST(offset)){
    if(type == AGS_TYPE_UINT){

    }else if(type == AGS_TYPE_UINT_FRAME){

    }else if(type == AGS_TYPE_LIST_FRAME){

    }
  }else if(AGS_IS_OFFSET_UINT_FRAME(offset)){
    if(type == AGS_TYPE_UINT){

    }else if(type == AGS_TYPE_LIST){

    }else if(type == AGS_TYPE_LIST_FRAME){

    }
  }else if(AGS_IS_OFFSET_LIST_FRAME(offset)){
    if(type == AGS_TYPE_UINT){

    }else if(type == AGS_TYPE_LIST){

    }else if(type == AGS_TYPE_UINT_FRAME){

    }
  }
}

AgsOffset*
ags_offset_new(GType type)
{
  AgsOffset *offset;

  if(type == NULL)
    offset = (AgsOffset *) g_object_new(AGS_TYPE_OFFSET_UINT, NULL);
  else if(type == AGS_TYPE_OFFSET_UINT || type == AGS_TYPE_LIST || type == AGS_TYPE_UINT_FRAME || type == AGS_TYPE_LIST_FRAME)
    offset = (AgsOffset *) g_object_new(type, NULL);
  else if(type == AGS_TYPE_OFFSET_LIST_FRAME_DOUBLE || type == AGS_TYPE_LIST_FRAME_DIMENSIONAL){
#ifdef __AGS_DEBUG__
    fprintf(stdout, stdout, "warning - in ags_offset_new() unsupported type: %s\n  not skipping\n\0", g_type_name(type));
#endif
    offset = (AgsOffset *) g_object_new(type, NULL);
  }
#ifdef __AGS_DEBUG__
  else
    fprintf(stdout, "warning - in ags_offset_new() unknown type\n  skipped\n\0");
#endif

  return(offset);
}

AgsOffset*
ags_offset_duplicate(AgsOffset *offset0, guint flags)
{
  AgsOffset *offset1;
  GList* ags_offset_duplicate_list_raw(GList *list0){
    GList *list1;

    list1 = (GList*) malloc(sizeof(GList));
    list1->data = list0->data;
    list1->next = NULL;

    while(list0 != NULL){
      list1->prev = (GList *) malloc(sizeof(GList));
      list1->prev->next = list1;
      list1 = list1->prev;

      GPOINTER_TO_UINT(list1->data) = GPOINTER_TO_UINT(list0->data);

      list0 = list0->prev;
    }

    list1->prev = NULL;

    return(list1);
  }

  offset1 = (AgsOffset *) g_object_new(G_TYPE_FROM_INSTANCE(offset0));
  offset1->flags = offset0->flags;

  if(AGS_IS_OFFSET_UINT(offset0)){
    AGS_OFFSET_UINT(offset1)->offset = AGS_OFFSET_UINT(offset0)->offset;
  }else if(AGS_IS_OFFSET_LIST(offset0)){
    AGS_OFFSET_LIST(offset1)->offset.data = offset0->offset_list.data;
    AGS_OFFSET_LIST(offset1)->offset.prev = ags_offset_duplicate_list_raw(AGS_OFFSET_LIST(offset0)->offset.prev);
    AGS_OFFSET_LIST(offset1)->offset.prev->next = &(AGS_OFFSET_LIST(offset1)->offset);

    if(AGS_OFFSET_DUPLICATE_MAXIMUM_SIZE & flags)
      AGS_OFFSET_LIST(offset1)->maximum_size = ags_offset_duplicate_list_raw(AGS_OFFSET_LIST(offset0)->offset_list);
    else
      AGS_OFFSET_LIST(offset1)->maximum_size = AGS_OFFSET_LIST(offset0)->maximum_size;
  }else if(AGS_IS_OFFSET_FRAME_UINT(offset0)){;
    AGS_OFFSET_LIST(offset1)->offset = AGS_OFFSET_LIST(offset0)->offset;

    if(AGS_OFFSET_DUPLICATE_MAXIMUM_SIZE & flags)
      AGS_OFFSET_LIST(offset1)->maximum_size = ags_offset_duplicate_list_raw(AGS_OFFSET_LIST(offset0)->maximum_size);
    else
      AGS_OFFSET_LIST(offset1)->maximum_size = AGS_OFFSET_LIST(offset0)->maximum_size;

    if(AGS_OFFSET_DUPLICATE_BASE & flags)
      AGS_OFFSET_LIST(offset1)->base = ags_offset_duplicate_list_raw(AGS_OFFSET_LIST(offset0)->base);
    else
      AGS_OFFSET_LIST(offset1)->base = AGS_OFFSET_LIST(offset0)->base;
  }else if(AGS_IS_OFFSET_LIST_FRAME(offset0)){
    GPOINTER_TO_UINT(AGS_OFFSET_FRAME_LIST(offset1)->offset.data) = GPOINTER_TO_UINT(AGS_OFFSET_FRAME_LIST(offset0)->offset.data);
    offset1->offset.prev = ags_offset_duplicate_list_raw(offset0->offset.prev);
    offset1->offset.prev->next = &(offset1.offset);

    if(AGS_OFFSET_DUPLICATE_BASE & flags){
      AGS_OFFSET_LIST_FRAME(offset1)->base = ags_offset_duplicate_list_raw(AGS_OFFSET_LIST(offset0)->base);
    }else
      AGS_OFFSET_LIST_FRAME(offset1)->base = AGS_OFFSET_LIST_FRAME(offset0)->base;

    if(AGS_OFFSET_DUPLICATE_FRAME_SIZE & flags){
      AGS_OFFSET_LIST_FRAME(offset1)->frame_size = ags_offset_duplicate_list_raw(AGS_OFFSET_LIST_FRAME(offset0)->frame_size);
    }else
      AGS_OFFSET_LIST_FRAME(offset1)->frame_size = AGS_OFFSET_LIST_FRAME(offset0)->frame_size;
  }else if(AGS_IS_OFFSET_LIST_FRAME_DOUBLE(offset0)){
    AgsOffsetListFrameDouble *list_frame_double0, *list_frame_double1;
    AgsOffsetListDoubleMember *list_double_member0, *list_double_member1;

  ags_offset_duplicate_frame_double0:

#ifdef __AGS_DEBUG__
    fprintf(stdout, "warning - in ags_offset_duplicate() duplicating unsupported type: AgsOffsetListFrameDouble\n  not skipping\n\0");
#endif

    list_frame_double0 = AGS_OFFSET_LIST_FRAME_DOUBLE(offset0);
    list_frame_double1 = AGS_OFFSET_LIST_FRAME_DOUBLE(offset1);

    list_double_member0 = &(list_frame_double0->list_double_member);
    list_double_member1 = &(list_frame_double1->list_double_member);

    while(list_double_member0 != NULL){
      GPOINTER_TO_UINT(list_double_member1->offset.data) = GPOINTER_TO_UINT(list_double_member0->offset.data);
      list_double_member1->offset.next = NULL;
      list_double_member1->offset.prev = ags_offset_duplicate_list_raw(list_double_member0->offset.prev);
      list_double_member1->offset.prev->next = &(list_double_member1->offset);

      list_double_member0 = list_double_member0->prev;
    }

    list_double_member1->prev = NULL;

    if(AGS_OFFSET_DUPLICATE_MAXIMUM_SIZE & flags)
      list_frame_double1->maximum_size = ags_offset_duplicate_list_raw(list_frame_double0->maximum_size);
    else
      list_frame_double1->maximum_size = list_frame_double0->maximum_size;

    if(AGS_OFFSET_DUPLICATE_BASE & flags)
      list_frame_double1->base = ags_offset_duplicate_list_raw(list_frame_double0->base);
    else
      list_frame_double1->base = list_frame_double0->base;

    if(AGS_OFFSET_DUPLICATE_FRAME_SIZE & flags)
      list_frame_double1->frame_size = ags_offset_duplicate_list_raw(list_frame_double0->frame_size);
    else
      list_frame_double1->frame_size = ags_offset_duplicate_list_raw(list_frame_double0->frame_size);
  }else if(AGS_IS_OFFSET_LIST_FRAME_DIMENSIONAL(offset1)){
    AgsOffsetListFrameDimensional *list_frame_dimensional0, *list_frame_dimensional1;
    AgsOffsetListDimensionalMember *list_dimensional_member0, *list_dimensional_member1;

#ifdef __AGS_DEBUG__
    fprintf(stdout, "warning - in ags_offset_duplicate() duplicating unsupported type: AgsOffsetListFrameDimensional\n  not skipping\n\0");
#endif

    list_frame_dimensional0 = AGS_OFFSET_LIST_FRAME_DIMENSIONAL(offset0);
    list_frame_dimensional1 = AGS_OFFSET_LIST_FRAME_DIMENSIONAL(offset1);

    list_frame_dimensional_member0 = &(AGS_OFFSET_LIST_FRAME_DIMENSIONAL(offset0)->list_dimensional_member);
    list_frame_dimensional_member1 = &(AGS_OFFSET_LIST_FRAME_DIMENSIONAL(offset1)->list_dimensional_member);

    while(list_dimensional_member0 != NULL){
      GPOINTER_TO_UINT(list_frame_dimensional_member1->offset.data) = GPOINTER_TO_UINT(list_frame_dimensional_member0->offset.data);
      list_frame_dimensional_member1->offset.next = NULL;
      list_frame_dimensional_member1->offset.prev = ags_offset_duplicate_list_raw(list_frame_dimensional_member0->offset.prev);
      list_frame_dimensional_member1->offset.prev->next = &(list_frame_dimensional_member1->offset);

      if(AGS_OFFSET_DUPLICATE_ATTACK & flags)
	list_frame_dimensional_member1->attack = ags_offset_duplicate_list_raw(list_frame_dimensional_member0->attack);
      else
	list_frame_dimensional_member1->attack = list_frame_dimensional_member0->attack;

      if(AGS_OFFSET_DUPLICATE_SIZE & flags)
	list_frame_dimensional_member1->frame_size = ags_offset_duplicate_list_raw(list_frame_dimensional_member0->frame_size);
      else
	list_frame_dimensional_member1->frame_size = ags_offset_duplicate_list_raw(list_frame_dimensional_member0->frame_size);

      list_frame_dimensional_member0 = list_frame_dimensional_member0->prev;
    }

    list_frame_dimensional_member1->prev = NULL;

    if(AGS_OFFSET_DUPLICATE_MAXIMUM_SIZE & flags)
      list_frame_dimensional1->maximum_size = ags_offset_duplicate_list_raw(list_frame_dimensional0->maximum_size);
    else
      list_frame_dimensional1->maximum_size = list_frame_dimensional0->maximum_size;

    if(AGS_OFFSET_DUPLICATE_BASE & flags)
      list_frame_dimensional1->base = ags_offset_duplicate_list_raw(list_frame_dimensional0->base);
    else
      list_frame_dimensional1->base = list_frame_dimensional0->base;

    if(AGS_OFFSET_DUPLICATE_MATRIX & flags){
      if(AGS_IS_OFFSET_LIST_FRAME_DOUBLE(list_frame_dimensional1->matrix))
	goto ags_offset_duplicate_frame_double0;
      else
	fprintf(stdout, "warning - in ags_offset_duplicate() only AgsOffsetListFrameDouble is valid for duplicating matrix\n  skipped\n\0");
    }else
      list_frame_dimensional1->matrix = list_frame_dimensional0->matrix;

    if(AGS_OFFSET_DUPLICATE_LEVEL & flags)
      list_frame_dimensional1->level = ags_offset_duplicate_list_raw(list_frame_dimensional0->level);;
    else
      list_frame_dimensional1->level = list_frame_dimensional0->level;
  }
#ifdef __AGS_DEBUG__
  else
    fprintf(stdout, "warning - in ags_offset_duplicate() unknown type\n  skipped\n\0");
#endif

  return(offset1);
}
