#ifndef __AGS_OFFSET_LIST_FRAME_DIMENSIONAL_H__
#define __AGS_OFFSET_LIST_FRAME_DIMENSIONAL_H__

#include <glib.h>
#include <glib-object.h>

#include "ags_offset.h"
#include "ags_offset_list_frame_double.h"

#define AGS_TYPE_OFFSET_LIST_FRAME_DIMENSIONAL    (ags_offset_list_frame_dimensional_get_type())
#define AGS_OFFSET_LIST_FRAME_DIMENSIONAL(obj)    (G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_OFFSET_LIST_FRAME_DIMENSIONAL, AgsOffsetListFrameDimensional))
#define AGS_IS_OFFSET_LIST_FRAME_DIMENSIONAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, AGS_TYPE_OFFSET_LIST_FRAME_DIMENSIONAL))

typedef struct _AgsOffsetListFrameDimensional AgsOffsetListFrameDimensional;
typedef struct _AgsOffsetListFrameDimensionalClass AgsOffsetListFrameDimensionalClass;
typedef struct _AgsOffsetListDimensionalMember AgsOffsetListDimensionalMember;

typedef enum{
  AGS_OFFSET_LIST_FRAME_DIMENSIONAL_MAXIMUM_SIZE_DYNAMIC,
  AGS_OFFSET_LIST_FRAME_DIMENSIONAL_MAXIMUM_SIZE_ATTACK,
  /* if none set of below attack points to entry of offset */
  AGS_OFFSET_LIST_FRAME_DIMENSIONAL_ATTACK_BIT_INDEX,
  AGS_OFFSET_LIST_FRAME_DIMENSIONAL_ATTACK_BYTE_INDEX,
  AGS_OFFSET_LIST_FRAME_DIMENSIONAL_ATTACK_WORD_INDEX,
}AgsOffsetDimensionalFlags; // read below by struct implementation

struct _AgsOffsetListFrameDimensional{
  AgsOffsetInstance offset_instance;

  AgsOffsetListDimensionalMember list_dimensional_member;

  guint flags;

  AgsOffset *maximum_size;
  AgsOffset *base;
  AgsOffsetListDoubleMember *matrix; // the matrix is a 2d bitmap
  GList *level;
};

struct _AgsOffsetListDimensionalMember{
  GList offset;
  AgsOffsetListDimensionalMember *next;
  AgsOffsetListDimensionalMember *prev;

  GList *size;
  GList *attack;
};

#endif /*__AGS_OFFSET_LIST_FRAME_DIMENSIONAL_H__*/
