#ifndef __AGS_TIMER_H__
#define __AGS_TIMER_H__

#include <glib.h>
#include <glib-object.h>

#include "ags_counter.h"

#define AGS_TYPE_TIMER                (ags_timer_get_type())
#define AGS_TIMER(obj)                ((AgsTimer*) G_TYPE_CHECK_INSTANCE_CAST(obj, AGS_TYPE_TIMER))
#define AGS_TIMER_CLASS(class)        ((AgsTimerClass*) G_TYPE_CHECK_CLASS_CAST(class, AGS_TYPE_TIMER))

typedef struct _AgsTimer AgsTimer;
typedef struct _AgsTimerClass AgsTimerClass;

typedef enum{
  AGS_TIMER_FADE_IN,
  AGS_TIMER_FADE_OUT,
  AGS_TIMER_USE_TREE, // default is task->offset to compare
  AGS_TIMER_FREE_DUPLICATED_OFFSET,
  AGS_TIMER_FREE_DUPLICATED_OFFSET_BASE,
}AgsTimerFlags;

struct _AgsTimer
{
  GObject object;

  guint flags;

  AgsCounter *counter;

  union _AgsTimerTask{
    GList *list;
    GNode *tree;
  }task;
};

struct _AgsTimerClass
{
  GObjectClass object;

  void (*start)(AgsTimer *timer);
  void (*run)(AgsTimer *timer);
  void (*stop)(AgsTimer *timer);
};

AgsTimer* ags_timer_new();

#endif /*__AGS_TIMER_H__*/
