#include <gtk/gtk.h>
#include "X/ags_window.h"

void (*gtk_window_destroy)(GtkObject *object);
void (*gtk_window_show)(GtkWidget *widget);
//extern void gtk_window_show(GtkWidget *widget);

void (*gtk_handle_box_destroy)(GtkObject *object);
void (*gtk_handle_box_show)(GtkWidget *widget);

void (*gtk_container_destroy)(GtkObject *object);
void (*gtk_widget_real_show)(GtkWidget *widget);

void ags_init();
void ags_colors_alloc();
GList* g_list_last_with_count(GList *list, guint *count);

extern GtkStyle *matrix_style;
extern GtkStyle *ffplayer_style;
extern GtkStyle *editor_style;

void
ags_init()
{
  GtkWindow *window;
  GtkHandleBox *handle_box;
  GtkContainer *container;

  gtk_window_destroy = NULL;
  gtk_window_show = NULL;

  gtk_handle_box_destroy = NULL;
  gtk_handle_box_show = NULL;

  gtk_container_destroy = NULL;
  gtk_widget_real_show = NULL;

  window = (GtkWindow *) gtk_window_new(GTK_WINDOW_POPUP);
  gtk_window_destroy = GTK_OBJECT_GET_CLASS(window)->destroy;
  gtk_window_show = GTK_WIDGET_GET_CLASS(window)->show;
  gtk_widget_destroy((GtkWidget *) window);

  handle_box = (GtkHandleBox *) gtk_handle_box_new();
  gtk_handle_box_destroy = GTK_OBJECT_GET_CLASS(handle_box)->destroy;
  gtk_handle_box_show = GTK_WIDGET_GET_CLASS(handle_box)->show;
  gtk_widget_destroy((GtkWidget *) handle_box);

  container = (GtkContainer *) gtk_vbox_new(FALSE, 0);
  gtk_container_destroy = GTK_OBJECT_GET_CLASS(container)->destroy;
  gtk_widget_real_show = GTK_WIDGET_GET_CLASS(container)->show;
  gtk_widget_destroy((GtkWidget *) container);
}

void
ags_colors_alloc()
{
  matrix_style = gtk_style_new();
  matrix_style->fg[0].red = 120 * (65535/255);
  matrix_style->fg[0].green = 220 * (65535/255);
  matrix_style->fg[0].blue = 120 * (65535/255);
  matrix_style->fg[0].pixel = (gulong)(120*65536 + 220*256 + 120);


  matrix_style->light[0].red = 100 * (65535/255);
  matrix_style->light[0].green = 200 * (65535/255);
  matrix_style->light[0].blue = 100 * (65535/255);
  matrix_style->light[0].pixel = (gulong)(100*65536 + 200*256 + 100);


  matrix_style->bg[0].red = 0 * (65535/255);
  matrix_style->bg[0].green = 80 * (65535/255);
  matrix_style->bg[0].blue = 0 * (65535/255);
  matrix_style->bg[0].pixel = (gulong)(0*65536 + 80*256 + 0);


  matrix_style->bg[1].red = 120 * (65535/255);
  matrix_style->bg[1].green = 220 * (65535/255);
  matrix_style->bg[1].blue = 120 * (65535/255);
  matrix_style->bg[1].pixel = (gulong)(120*65536 + 220*256 + 120);

  matrix_style->bg[2].red = 120 * (65535/255);
  matrix_style->bg[2].green = 220 * (65535/255);
  matrix_style->bg[2].blue = 120 * (65535/255);
  matrix_style->bg[2].pixel = (gulong)(120*65536 + 220*256 + 120);


  matrix_style->base[0].red = 120 * (65535/255);
  matrix_style->base[0].green = 220 * (65535/255);
  matrix_style->base[0].blue = 120 * (65535/255);
  matrix_style->base[0].pixel = (gulong)(120*65536 + 220*256 + 120);


  /*  matrix_style->fg[1] = matrix_green;
  matrix_style->fg[2] = matrix_green;
  matrix_style->fg[3] = matrix_green;
  matrix_style->fg[4] = matrix_green;

  matrix_style->bg[0] = matrix_led_bg;
  matrix_style->bg[1] = matrix_led_bg;
  matrix_style->bg[2] = matrix_led_bg;
  matrix_style->bg[2] = matrix_led_bg;
  matrix_style->bg[3] = matrix_led_bg;
  matrix_style->bg[4] = matrix_led_bg;
  */

  /* ffplayer style */
  ffplayer_style = gtk_style_new();
  ffplayer_style->fg[0].red = 120 * (65535/255);
  ffplayer_style->fg[0].green = 120 * (65535/255);
  ffplayer_style->fg[0].blue = 220 * (65535/255);
  ffplayer_style->fg[0].pixel = (gulong)(120*65536 + 120*256 + 220);



  ffplayer_style->bg[0].red = 4 * (65535/255);
  ffplayer_style->bg[0].green = 8 * (65535/255);
  ffplayer_style->bg[0].blue = 56 * (65535/255);
  ffplayer_style->bg[0].pixel = (gulong)(4*65536 + 8*256 + 56);

  ffplayer_style->bg[1].red = 120 * (65535/255);
  ffplayer_style->bg[1].green = 120 *(65535/255);
  ffplayer_style->bg[1].blue = 120 * (65535/255);
  ffplayer_style->bg[1].pixel = (gulong)(120*65536 + 120*256 + 120);


  ffplayer_style->bg[2].red = 120 * (65535/255);
  ffplayer_style->bg[2].green = 120 *(65535/255);
  ffplayer_style->bg[2].blue = 120 * (65535/255);
  ffplayer_style->bg[2].pixel = (gulong)(255*65536 + 255*256 + 255);


  ffplayer_style->mid[0].red = 4 * (65535/255);
  ffplayer_style->mid[0].green = 8 * (65535/255);
  ffplayer_style->mid[0].blue = 56 * (65535/255);
  ffplayer_style->mid[0].pixel = (gulong)(4*65536 + 8*256 + 56);


  ffplayer_style->light[0].red = 120 * (65535/255);
  ffplayer_style->light[0].green = 120 * (65535/255);
  ffplayer_style->light[0].blue = 220 * (65535/255);
  ffplayer_style->light[0].pixel = (gulong)(120*65536 + 120*256 + 220);


  ffplayer_style->base[0].red = 120 * (65535/255);
  ffplayer_style->base[0].green = 120 * (65535/255);
  ffplayer_style->base[0].blue = 220 * (65535/255);
  ffplayer_style->base[0].pixel = (gulong)(120*65536 + 120*256 + 220);


  /* editor style */
  editor_style = gtk_style_new();
  editor_style->fg[0].red = 255 * (65535/255);
  editor_style->fg[0].green = 240 *(65535/255);
  editor_style->fg[0].blue = 200 * (65535/255);
  editor_style->fg[0].pixel = (gulong)(255*65536 + 240*256 + 200);

  editor_style->bg[0].red = 255 * (65535/255);
  editor_style->bg[0].green = 255 *(65535/255);
  editor_style->bg[0].blue = 255 * (65535/255);
  editor_style->bg[0].pixel = (gulong)(255*65536 + 255*256 + 255);


  editor_style->mid[0].red = 150 * (65535/255);
  editor_style->mid[0].green = 150 *(65535/255);
  editor_style->mid[0].blue = 250 * (65535/255);
  editor_style->mid[0].pixel = (gulong)(150*65536 + 150*256 + 250);


  editor_style->base[0].red = 250 * (65535/255);
  editor_style->base[0].green = 250 *(65535/255);
  editor_style->base[0].blue = 250 * (65535/255);
  editor_style->base[0].pixel = (gulong)(250*65536 + 250*256 + 250);
}

GList*
g_list_last_with_count(GList *list, guint *count)
{
  guint i;

  for(i = 0; list->next != NULL; i++)
    list = list->next;

  *count = i;

  return(list);
}

int
main(int argc, char **argv)
{
  AgsWindow *window;

  gtk_init(&argc, &argv);

  ags_init();
  ags_colors_alloc();
  window = ags_window_new();

  gtk_widget_show((GtkWidget*) window);
  ags_window_connect(window);

  gtk_main();

  return(0);
}
